#include <stdio.h>

#define octet unsigned char
#define EOL 10


main (narg, varg)
int narg;
char *varg [];
{
    int car;     /* caractere du fichier */
    octet optv;  /* presence de l'option -v */

    /* initialisation */
    optv = 0;

    /* positionnement sur le premier argument */
    varg++;
    narg--;

    /* recuperation des options */
    while (**varg == '-')
    {
        /* prise en compte de l'option -v */
        if (strcmp (*varg, "-v") == 0)
            optv = 1;
        else
        {
            fprintf (stderr, "Syntaxe : cat [-v] [<liste de fichiers>]\n");
            exit ();
        }

        /* passer a l'argument suivant */
        varg++;
        narg--;
    }

    /* boucle de travail */
    do
    {
        /* ouvrir le fichier a lire */
        if (narg > 0)
        {
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        /* lire le premier caractere */
        car = getchar ();

        /* tantque non fin de fichier */
        while (car != EOF)
        {
            /* editer le caractere */
            if (car >= ' ' || car == EOL || optv == 0)
                putchar (car);
            else
            {
                /* edition en clair des caracteres de controle si option -v */
                putchar ('^');
                putchar (car + '@');
            }

            /* lire le caractere suivant */
            car = getchar ();

        }

        /* passer a l'argument suivant */
        varg++;
        narg--;
    }
    while (narg > 0);
}