#include <stdio.h>

#define carspemax 20


static char *chainecarspe [carspemax];
static char carspe [carspemax];
static int  nbcarspe = 0;

static char convcaretendu [128] = { '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', '',
                                    '', '', '', '', '', '', '', ''  };

static int espace;


main (narg, varg)
int narg;
char *varg [];
{
    int car;


    initab ();

    do
    {
        *varg++;
        narg--;

        if (narg > 0)
        {
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        espace = 0;
        car = getchar ();

        while (car != EOF)
        {
            switch (car)
            {
                case '&' : trtcarspe ();
                           break;

                case '<' : trtoption ();
                           break;

                default  : if (espace > 0)
                           {
                               if (car != ' ')
                                   putchar (' ');
                           }

                           if (car & 0x80)
                               putchar (convcaretendu [car & 0x7f]);
                           else
                           {
                               if (car == ' ')
                                   espace = -1;
                               else
                                   espace = 0;

                               putchar (car);
                           }
            }

            car = getchar ();
        }
    }
    while (narg > 1);
}


initab ()
{
    memo ("eacute", '');
    memo ("egrave", '');
    memo ("agrave", '');
    memo ("ecirc",  '');
    memo ("ugrave", '');
    memo ("ccedil", '');
    memo ("icirc",  '');
    memo ("ocirc",  '');
    memo ("Ccedil", '');
    memo ("acirc",  '');
    memo ("aacute", '');
    memo ("igrave", '');
    memo ("iacute", '');
    memo ("oacute", '');
    memo ("ograve", '');
    memo ("ucirc",  '');
    memo ("uacute", '');
}



memo (char *chaine, char caract)
{
    chainecarspe [nbcarspe] = chaine;
    carspe [nbcarspe ++] = caract;
}



trtcarspe ()
{
    char carmemo [8];
    int nbcarmemo;
    int trouve;
    int numcarspe;
    int poschaine;


    nbcarmemo = 0;
    trouve = 0;
    numcarspe = 0;

    while (trouve == 0 && numcarspe < nbcarspe)
    {
        poschaine = 0;
        trouve = 1;

        while (chainecarspe [numcarspe][poschaine] != 0 && trouve)
        {
            if (nbcarmemo <= poschaine)
                carmemo [nbcarmemo ++] = getchar ();

            trouve = carmemo [poschaine] == chainecarspe [numcarspe][poschaine];

            poschaine ++;
        }

        if (nbcarmemo <= poschaine)
            carmemo [nbcarmemo ++] = getchar ();

        trouve = carmemo [poschaine] == ';';

        numcarspe ++;
    }

    if (trouve)
        putchar (carspe [numcarspe - 1]);
    else
        for (poschaine = 0; poschaine < nbcarmemo; poschaine ++)
            putchar (carmemo [poschaine]);
}



trtoption ()
{
    int car, car1;


    car = getchar ();

    if (car == '/')
        car = getchar ();

    if (car != '>')
    {
        car1 = car;
        car = getchar ();
    }

    if ((car1 == 'L' && car == 'I') ||
        (car1 == 'T' && car == 'R') ||
        (car1 == 'B' && car == 'R'))
    {
        putchar ('\n');
        espace = 0;
    }
    else if (car1 == 'P' && car == '>')
    {
        putchar ('\n');
        putchar ('\n');
        espace = 0;
    }
    else if (car1 == 'T' && car == 'D')
    {
        putchar ('\t');
        espace = 0;
    }
    else if (espace == 0)
        espace = 1;

    while (car != '>' && car != EOF)
        car = getchar ();
}