#include <stdio.h>


main (narg, varg)
int narg;
char *varg [];
{
    int val;
    char *valeur;

    if (narg != 2)
        printf ("Syntaxe : delay <nombre de millisecondes>\n");
    else
    {
         varg++;
         valeur = *varg;
         val = 0;

         while (('0' <= *valeur) && (*valeur <= '9'))
         {
              val = (val * 10) + (*valeur - '0');
              valeur ++;
         }
         
         if (*valeur == 0)
             /* la fonction delay ne marche avec les calculateurs
                rapides que si elle est compile avec Turbo C++ (3.0 min) */
             delai (val);
         else
             printf ("Syntaxe : delay <nombre de millisecondes>\n");
    }
}



delai (duree)
unsigned duree;
{
    long pas_etalon;
    long pas_avant_tic;
    long pas_restants;
    long der_heure;
    unsigned ecoule;


    if (duree > 0)
    {
        duree = duree + (duree / 1000);

        pas_avant_tic = 0;

        der_heure = clock ();

        do
            pas_avant_tic ++;
        while (der_heure == clock ());

        der_heure ++;
        pas_etalon = 0;

        do
            pas_etalon ++;
        while (der_heure == clock ());

        ecoule = 55 + (55 * pas_avant_tic / pas_etalon);

        if (duree > ecoule)
            duree = duree - ecoule;
        else
            duree = 0;

        while (duree >= 55)
        {
            der_heure ++;

            while (der_heure == clock ());

            duree = duree - 55;
        }

        pas_restants = duree * pas_etalon / 55;

        while (pas_restants-- > 0)
            der_heure = clock ();
    }
}