#include <stdio.h>
#include <dos.h>


main (narg, varg)
int narg;
char *varg [];
{
    int jour, mois, an, jsem;
    struct date datecur;


    if (narg >= 4)
        an = atoi (varg [3]);
    else
    {
        getdate (&datecur);
        an = datecur.da_year;
    }

    if (narg >= 3)
        mois = atoi (varg [2]);
    else
        mois = datecur.da_mon;

    if (narg >= 2)
        jour = atoi (varg [1]);
    else
        jour = datecur.da_day;

    if (an < 100)
    {
        if (an < 40)
            an = an + 2000;
        else
            an = an + 1900;
    }

    mois = mois - 2;

    if (mois <= 0)
    {
        mois = mois + 12;
        an = an - 1;
    }

    /* quivalent : (jour + (mois * 2.59) + (an * 1.25)
                                            - (an / 100) * 0,75 - 1) % 7
       sans utiliser l'arithmtique flotante qui augmenterait
       fortement la taille de l'excutable */
    jsem = (jour + (mois * 44 / 17) + (an * 5 / 4)
                                    - (((an / 100) + 1) * 3 / 4) - 1) % 7;

    switch (jsem)
    {
        case 0 : puts ("Lundi");
                 break;

        case 1 : puts ("Mardi");
                 break;

        case 2 : puts ("Mercredi");
                 break;

        case 3 : puts ("Jeudi");
                 break;

        case 4 : puts ("Vendredi");
                 break;

        case 5 : puts ("Samedi");
                 break;

        case 6 : puts ("Dimanche");
                 break;
    }
}
