#include <stdio.h>

#define EOL     10


main (narg, varg)
int narg;
char *varg [];
{
    static int car, nbmaxlf, nbsautlig, nblancs;
    char   *caroption;


    varg ++;
    narg --;

    if (narg > 0 && **varg == '-')
    {
        nbmaxlf = 0;

        caroption = varg [0] + 1;

        while (*caroption != 0)
        {
            if ('0' <= *caroption && *caroption <= '9')
            {
                nbmaxlf = (nbmaxlf * 10) + (*caroption & 0x0F);

                caroption ++;
            }
            else
            {
                fputs ("Syntaxe : maxlf [-nombre max de sauts de lignes] <liste de fichiers>\n", stderr);
                exit (-1);
            }
        }

        varg ++;
        narg --;
    }
    else
        nbmaxlf = 2;

    do
    {
        if (narg > 0)
        {
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        nbsautlig = 0;
        nblancs   = 0;

        car = getchar ();

        while (car != EOF)
        {
            if (car == EOL)
            {
                if (nbsautlig <= nbmaxlf)
                {
                    putchar (EOL);
                    nbsautlig ++;
                }

                nblancs = 0;
            }
            else if (car == ' ')
                nblancs ++;
            else
            {
                while (nblancs > 0)
                {
                    putchar (' ');
                    nblancs --;
                }

                putchar (car);

                nbsautlig = 0;
            }

            car = getchar ();
        }

        varg++;
        narg--;
    }
    while (narg > 0);
}
