#include <stdio.h>
#include <io.h>

extern int errno;

main (narg, varg)
int narg;
char *varg [];
{
    /* positionnement sur le premier augument */
    *varg++;

    /* controle de la syntaxe */
    if (narg < 2)
        fprintf (stderr, "Syntaxe : mkd <liste de rpertoires>\n");
    else
    {
        /* boucle de travail */
        while (--narg > 0)
        {
            /* test d'existence du rpertoire */
            if (access (*varg, 0) == 0)
                fprintf (stderr, "%s dj existant\n", *varg);
            else
                /* cration du rpertoire */
                if (mkdir (*varg) == -1)
                {
                    /* traitement d'erreur */
                    if (errno == 2)
                        fprintf (stderr, "%s : chemin d'accs incorrect\n",
                                                                    *varg);
                    else
                        perror (*varg);
                }

            /* passage  l'argument suivant */
            *varg++;
        }
    }
}