/* Ce programme rawbloc doit tre compil de prfrence avec le
   modle mmoire compact pour gagner de la RAM  l'excution */

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dir.h>
#include <mem.h>
#include <alloc.h>
#include <dos.h>
#include <time.h>
#include "accent.h"

#define histdefaut  "c:/config/hist"  /* fichier historique par dfaut */

#define freq_deb     400    /* frquences limites de l'alarme */
#define freq_max    1500
#define freq_fin     100
#define topmin      1092    /* tops d'horloge lmentaires par minute */

#define minmemocom 50000    /* mmoire minimum pour lancer une commande */

#define EOL           10
#define CTRL          12
#define CR            13
#define ESC           27


static char carhist = '!';  /* caractre de reconnaissance historique */
static char carfin  = '@';  /* caractre reconnaissance abrviation fin ligne */

static int  car;            /* caractre saisi au clavier */
static char carpred;        /* caractre saisi prcdent */
static char ligne [81][2];  /* image de la ligne saisie au clavier */
static char clavier [81];   /* ligne saisie au clavier */
static char nbcar;          /* longueur de la commande  excuter */
static char pos;            /* position courante dans le buffer clavier */
static char numlig;         /* numro de la ligne ou l'on est positionn */
static char *chaine;        /* portion de la ligne saisie  excuter */

static char PS1     [80];   /* prompt */
static char varprompt;      /* indicateur affichage ou interprtation prompt */
static char affps1  [80];   /* commande  excuter pour interprter le prompt */

static char chpred [19][81]; /* mmorisation des 19 dernires commandes */
static char szpred [19];    /* longueur des 19 dernires commandes */
static char pospred;        /* position d'un commande dans l'historique */
static char nbmemo;         /* nombre de commandes mmorises */
static char autoexec;       /* indicateur excution automatique commande rappele */
static char fichist [40];   /* nom du fichier historique */

static char valdir [80];    /* nom du rpertoire courant */
static char accent = 0;     /* indicateur de traitement des accents */
static char ansi;           /* indique si l'on utilise le pilote ansi.sys */

static char memdir [80];    /* mmorisation du rpertoire courant */
static char memdsk;         /* et du disque courant */

static long attente_car;    /* nombre de minutes d'inactivit avant alarme */

static struct date dateref;    /* la mmorisation de la date et de l'heure */
static struct date datecur;    /* permet de vrifier si le changement      */
static struct time heuravant;  /* de date s'effectue bien  minuit         */
static struct time heurapres;  /* et de corriger la date si ncessaire     */
static long clockavant, clockapres;

static char *arg0;          /* pour relancer rawbloc si mode texte change  */
static char ficaide [40];   /* nom du fichier d'aide en ligne              */

/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    if (farcoreleft () < minmemocom)
    {
        fputs ("Mmoire insuffisante pour excuter correctement des commandes\n",
                                                                       stderr);
        exit (0);
    }

    /* mmorisation de la commande rawbloc */
    arg0 = *varg;

    /* fabrication du nom du fichier d'aide en ligne */
    strcpy (ficaide, arg0);
    strcpy (ficaide + strlen (arg0) - 3, "HLP");

    /* dbut de l'initialisation */
    initdeb ();

    /* prise en compte si ncssaire des arguments du programme */
    if (--narg > 0)
        trtarg (narg, varg + 1);

    /* fin de l'initialisation */
    initfin ();

    /* saisie et excution des commandes */
    saisie ();
}

/* initialisation du nom du fichier tampon, de l'historique et du prompt */
initdeb ()
{
    /* rcupration de la date et de l'heure */
    getdate (&datecur);
    gettime (&heurapres);

    /* initialisation de l'historique */
    pospred = 0;
    nbmemo  = 0;

    /* pas encore de fichier historique */
    *fichist = 0;

    /* aucun nom de rpertoire mmoris */
    *memdir = 0;

    /* rcupration ou initialisation de carhist et carfin */
    if (getenv ("carhist") == 0)
    {
        carhist = '!';
        putenv ("carhist=!");
    }
    else
        memcpy (&carhist, getenv ("carhist"), 1);

    if (getenv ("carfin") == 0)
    {
        carfin = '@';
        putenv ("carfin=@");
    }
    else
        memcpy (&carfin, getenv ("carfin"), 1);

    /* rcupration ou initialisation du prompt */
    if (getenv ("PS1") == 0)
        putenv ("PS1=Et aprs ?");

    sprintf (PS1, "%s", getenv ("PS1"));
    majprompt ();
}

/* traitements des arguments */
trtarg (narg, varg)
int narg;
char *varg [];
{
    char typecom;          /* type d'action sur le fichier historique */


    /* tantqu'il y a des arguments  traiter */
    while (narg > 0)
    {
        /* si l'argument commence par un '-' */
        if (**varg == '-')
        {
            /* utilisation du fichier historique par dfaut */
            if ((strcmp (*varg, "-hd") == 0) || (strcmp (*varg, "-rhd") == 0)
                                             || (strcmp (*varg, "-shd") == 0))
            {
                typecom = varg [0][1];

                if (typecom != 's')
                    recuphist (histdefaut);

                if (typecom != 'r')
                    sauvhist (histdefaut);

                if (typecom != 's')
                {
                    setdisk (*valdir - 'A');
                    chdir (valdir);
                }
            }

            /* utilisation d'un fichier historique passe en paramtre */
            else if ((strcmp (*varg, "-h") == 0) || (strcmp (*varg, "-rh") == 0)
                                                 || (strcmp (*varg, "-sh") == 0))
            {
                typecom = varg [0][1];
                varg++;
                narg--;

                if (typecom != 's')
                    recuphist (*varg);

                if (typecom != 'r')
                    sauvhist (*varg);

                if (typecom != 's')
                {
                    setdisk (*valdir - 'A');
                    chdir (valdir);
                }
            }

            /* excution d'un fichier de commandes */
            else if (strcmp (*varg, "-c") == 0)
            {
                varg++;
                narg--;
                ficinit (*varg);
            }

            /* slection du traitement des accents */
            else if (strcmp (*varg, "-a") == 0)
            {
                varg++;
                narg--;
                accent = 1;
            }

            else
                psyntaxe (*varg);
        }

        /* sinon traitement d'une affectation */
        else
        {
            /* affectation d'un caractre de reconnaissance */
            if (varg [0][2] == '=' && varg [0][0] == 'c')
            {
                if (varg [0][1] == 'h')
                    carhist = varg [0][3];

                else if (varg [0][1] == 'f')
                    carfin = varg [0][3];

                else
                    psyntaxe (*varg);
            }

            /* affectation du prompt */
            else if (varg [0][3] == '=')
            {
                varg [0][3] = 0;

                if (strcmp (*varg, "PS1") == 0)
                {
                    sprintf (PS1, "%s", &varg [0][4]);
                    majprompt ();
                }
                else
                    psyntaxe (*varg);
            }

            else
                psyntaxe (*varg);
        }

        /* passer aux arguments suivants */
        varg++;
        narg--;
    }
}

/* fin d'initialisation et dition du rpertoire de dmarrage */
initfin ()
{
    char i;     /* compteur */


    /* ncssaire pour la compatibilit avec l'interprteur de MS-DOS */
    if (getenv ("alarme") == 0 && getenv ("ALARME") != 0)
        memcpy (getenv ("ALARME") - 7, "alarme", 6);

    /* convertir si ncssaire la dure de l'alarme en tops d'horloge */
    attente_car = atol (getenv ("alarme")) * topmin;

    /* mettre  jour si ncssaire le fichier historique */
    if (*fichist != 0)
        majfichist ();

    /* diter le rpertoire courant */
    if (*valdir == 0)
        strcpy (valdir, getcwd (0, 80));

    for (i = 0; valdir [i] != 0; i++)
    {
        if (valdir [i] == '\\')
            valdir [i] = '/';

        putchar (valdir [i]);
    }

    putchar (EOL);

    /* vrifier si le pilote ansi.sys est install */
    testansi ();

    /* diter le prompt */
    prompt ();
}

/* excution du fichier d'initialisation */
ficinit (fichier)
char fichier [];
{
    FILE *adrfc;  /* descripteur du fichier de commandes */


    /* ouvrir le fichier de commandes */
    adrfc = fopen (fichier, "rb");

    /* si l'ouverture s'est bien deroule */
    if (adrfc != 0)
    {
        /* initialisation */
        pos = 0;
        car = getc (adrfc);

        /* tantque le fichier de commande n'a pas t trait entirement */
        while (car != EOF)
        {
            /* si fin de ligne */
            if (car == EOL)
            {
                /* excuter la commande mmorise */
                execom ();
                pos = 0;
            }

            /* sinon mmoriser le caractre lu */
            else if (pos < 80)
                clavier [pos++] = car;

            /* lire le caractre suivant */
            car = getc (adrfc);
        }

        /* fermer le fichier de commandes */
        fclose (adrfc);
    }

    /* sinon diter le message d'erreur adquat */
    else if (access (fichier, 0) == 0)
        printf ("Fichier %s : droits d'accs insuffisants\n", fichier);
    else
        printf ("Fichier %s inexistant\n", fichier);
}

/* chargement du fichier historique */
recuphist (fichier)
char fichier [];
{
    FILE *lecfichist;  /* descripteur du fichier historique en lecture */
    char i;            /* compteur */


    /* si ce fichier existait dj */
    if (access (fichier, 0) == 0)
    {
        /* ouvrir le fichier historique en lecture */
        lecfichist = fopen (fichier, "rb");

        /* si l'ouverture s'est bien deroule */
        if (lecfichist != 0)
        {
            /* vrification de la cohrence du fichier historique */
            getc (lecfichist);
            getc (lecfichist);
            getc (lecfichist);

            if (getc (lecfichist) == ':' && getc (lecfichist) == '/')
            {
                /* cohrence satisfaisante : on lit le fichier */
                rewind (lecfichist);

                /* rcuprer les caractres de reconnaissance */
                carhist = getc (lecfichist);
                carfin  = getc (lecfichist);

                /* et mettre  jour les variables d'environnement */
                memcpy (getenv ("carhist"), &carhist, 1);
                memcpy (getenv ("carfin"), &carfin, 1);


                /* rcuprer le rpertoire */
                i = 0;

                do
                    valdir [i] = getc (lecfichist);
                while (valdir [i++] > ' ');


                /* controle de validit suplmentaire */
                if (valdir [i - 1] == 0)
                {
                    /*  rcuprer le prompt */
                    i = 0;

                    do
                        PS1 [i] = getc (lecfichist);
                    while (PS1 [i++] != 0);

                    majprompt ();


                    /* rcuprer l'historique des commandes */
                    nbcar = getc (lecfichist);

                    while (nbcar > 0)
                    {
                        /* une commande de plus sera mmorise */
                        if (nbmemo < 19)
                            nbmemo++;

                        /* calcul de l'emplacement pour l'archivage */
                        pospred = (pospred + 1) % 19;

                        /* archivage du nombre de caractres */
                        szpred [pospred] = nbcar;

                        /* archivage de la commande */
                        while (nbcar-- > 0)
                            chpred [pospred][nbcar] = getc (lecfichist);

                        /* lire la taille de la commande suivante */
                        nbcar = getc (lecfichist);
                    }

                    /* fermer le fichier historique */
                    fclose (lecfichist);
                }
            }
            /* sinon message d'erreur */
            else
            {
                puts ("Fichier historique non conforme");

                /* on rinitialise dans ce cas */
                carhist = '!';
                carfin = '@';
                *valdir = 0;
            }
        }
        /* sinon message d'erreur */
        else
            puts ("Fichier historique : droits d'accs en lecture insuffisants");
    }
}

/* initialisation de la sauvegarde dans un fichier historique */
sauvhist (fichier)
char fichier [];
{
    /* si un fichier n'a pas dj t slectionne */
    if (*fichist == 0)
        /* slection du fichier */
        strcpy (fichist, fichier);
    else
        printf ("La sauvegarde s'effectue dj dans le fichier : %s\n",fichist);
}

/* saisie et excution des commandes */
saisie ()
{
    char debl;  /* indique si l'on a dj saisi des caractres valides */
    char i;


    /* initialisation */
    debl = 1;

    /* rpter sans fin */
    while (1)
    {
        /* lire un caractre */
        carpred = car;
        car = leccar ();

        /* si on n'a pas encore lu de caractre valide */
        if (debl == 1)
        {
            /* traitement en fonction du caractre lu */
            switch (car)
            {
                /* caractre spcial */
                case   0 : debl = 0;
                           trtseq ();
                           break;

                /* validation ou break sur une commande vide */
                case EOL :
                case  CR :
                case   3 : crlf ();
                           prompt ();
                           break;

                /* filtrage des caractres voisins de la touche return */
                case '\\':
                case ']' :
                case   8 : break;

                /* sortie du programme si control D */
                case   4 : exit (0);

                /* autre : on prend le caractre en compte */
                default  : putchar (car);
                           debl = 0;
            }
        }
        /* sinon */
        else
        {
            /* traitement d'un autre caractre de la ligne */
            switch (car)
            {
                /* caractre spcial */
                case  0 : trtseq ();
                          break;

                /* touche break */
                case  3 : crlf ();
                          prompt ();
                          debl = 1;
                          break;

                /* sortie du programme si control D en premire colonne */
                case  4 : if (wherex () == 1)
                          {
                              if (ansi == 1)
                                  putseq ('K');

                              exit (0);
                          }
                          else
                              putchar (car);

                          break;

                /* validation (return ou line-feed) */
                case EOL:
                case CR : if (ansi == 1)
                              putseq ('K');

                          pos = wherex () - 1;
                          numlig = wherey ();
                          gettext (1, numlig, pos, numlig, ligne);

                          crlf ();

                          if (ansi == 1)
                              clrfin ();

                          /* si bonne lecture par gettext */
                          if (ligne [0][1] != -1)
                          {
                             /* rcuprer la ligne saisie au clavier */
                             for (i = 0; i < pos; i++)
                                 clavier [i] = ligne [i][0];

                             /* et l'excuter */
                             execom ();
                          }
                          else
                          {
                              /* sinon relancer rawbloc */
                              printf ("Le mode texte a t chang, rawbloc relanc");

                              strcpy (clavier, arg0);

                              if (*fichist == 0)
                                  puts (", historique perdu");
                              else
                              {
                                  putchar ('\n');

                                  strcat (clavier, " -h ");
                                  strcat (clavier, fichist);
                              }

                              system (clavier);

                              /* vrifier si l'on peut retourner dans cette version de rawbloc */
                              gettext (1, 1, 1, 1, ligne);

                              if (ligne [0][1] == -1)
                                  exit (0);
                              else
                              {
                                  if (*fichist != 0)
                                      recuphist (fichist);

                                  prompt ();
                              }
                          }

                          debl = 1;
                          break;

                /* autre : on mmorise le caractre aprs
                           traitement ventuel des accents */
                default : if (accent == 1)
                           {
                               switch (car)
                               {
/* recentrage  gauche */

case '\'': if (carpred == 'e')
               memaccent (eaigu);
           break;

case '`' : if (carpred == 'a')
               memaccent (agrave);

           else if (carpred == 'e')
               memaccent (egrave);

           else if (carpred == 'u')
               memaccent (ugrave);

           break;

case '^' : if (carpred == 'a')
               memaccent (acirc);

           else if (carpred == 'e')
               memaccent (ecirc);

           else if (carpred == 'i')
               memaccent (icirc);

           else if (carpred == 'o')
               memaccent (ocirc);

           else if (carpred == 'u')
               memaccent (ucirc);

           break;

case '"' : if (carpred == 'e')
           {
               putchar (car);
               car = leccar ();

               if (car == '"')
               {
                   putchar (8);
                   memaccent (etrema);
               }
           }
           else if (carpred == 'i')
           {
               putchar (car);
               car = leccar ();

               if (car == '"')
               {
                   putchar (8);
                   memaccent (itrema);
               }
           }
           break;

case ',' : if (carpred == 'c')
           {
               putchar (car);
               car = leccar ();

               if (car == 'a' || car == 'o' || car == 'u')
               {
                   putchar (8);
                   putchar (8);
                   putchar (ccedille);
               }
           }
           else if (carpred == 'C')
           {
               putchar (car);
               car = leccar ();

               if (car == 'a' || car == 'o' || car == 'u')
               {
                   putchar (8);
                   putchar (8);
                   putchar (Ccedille);
               }
           }
           break;

/* fin du recentrage  gauche */

                               }
                           }
                           putchar (car);
            }
        }
    }
}

/* traitement d'un caractre spcial */
trtseq ()
{
    char x, y;        /* coordonnes du curseur */
    char carcur [2];  /* image vido du caractre courant */


    /* lecture du caractre spcial */
    car = leccar ();

    switch (car)
    {
        /* touche F1 */
        case 0x3B : puts ("aide");
                    aide ();
                    break;

        /* touche F3 */
        case 0x3D : putchar (carhist);
                    puts ("memdir");
                    memodir ();
                    break;

        /* touche F4 */
        case 0x3E : putchar (carhist);
                    puts ("resdir");
                    restordir ();
                    break;

        /* touche F6 */
        case 0x40 : putchar (carhist);

        /* touche F5 */
        case 0x3F : putchar (carhist);
                    puts ("rappel");
                    autoexec = 1 - (car & 1);
                    rappel ();
                    break;

        /* touche HOME */
        case 0x47 : putchar (CR);
                    break;

        /* monte du curseur */
        case 0x48 : if (ansi == 1)
                        putseq ('A');
                    else
                        putchar (7);

                    break;

        /* descente du curseur */
        case 0x50 : if (ansi == 1)
                        putseq ('B');
                    else
                        putchar (7);

                    break;

        /* avance du curseur */
        case 0x4d : if (ansi == 1)
                        putseq ('C');
                    else
                    {
                        x = wherex ();
                        y = wherey ();
                        gettext (x, y, x, y, carcur);
                        putchar (carcur [0]);
                    }

                    break;

        /* recul du curseur */
        case 0x4b : putchar (8);
                    break;

        /* touche END */
        case 0x4f : if (ansi == 1)
                    {
                        y = wherey ();
                        gettext (1, y, 80, y, ligne);

                        x = 79;

                        while (ligne [x][0] == ' ' && x >= 0)
                            x--;

                        putchar (CR);

                        if (x >= 0)
                            printf ("%c%c[%dC", CR, ESC, x + 1);
                    }
                    else
                        putchar (7);

                    break;

        /* insertion de caractre */
        case 0x52 : x = wherex ();
                    y = wherey ();
                    movetext (x, y, 79, y, x + 1, y);
                    putchar (' ');
                    putchar (8);
                    break;

        /* suppression de caractre */
        case 0x53 : x = wherex ();
                    y = wherey ();
                    movetext (x + 1, y, 80, y, x, y);
                    if (y < 25)
                    {
                        gotoxy (80, y);
                        putchar (' ');
                        gotoxy (x, y);
                    }
                    break;

        /* autre caractre, on met un bip */
        default   : putchar (7);
    }
}


/* mmorisation d'un caractre accentu */
memaccent (caccent)
char caccent;
{
    putchar (8);

    car = caccent;
}

/* excution de la commande tape */
execom ()
{
    char i;

    /* supprimer ventuellement le '\' ou le ']' en fin de ligne */
    if (pos > 1 && (clavier [pos - 1] == '\\' || clavier [pos - 1] == ']'))
        pos--;

    /* terminer la chaine de caractres saisie */
    clavier [pos] = 0;

    /* se positionner sur le premier caractre significatif de la ligne */
    for (i = 0; clavier [i] == ' '; i++);

    /* si la ligne saisie n'est pas vide */
    if (i < pos)
    {
        /* remplacement ventuel de carfin par sa valeur */
        if (clavier [pos - 1] == carfin && clavier [pos - 2] == ' ')
            trtcarfin ();

        /* se positionner en dbut de chaine */
        chaine = &clavier [i];

        /* calculer le nombre de caractres significatifs */
        nbcar = pos - i;


        /* traitement des commandes particulires */

        if (chaine [0] == carhist)
            historique ();

        else if (tstcom ("exit"))
            exit (0);

        else if (tstcom ("aide"))
            aide ();

        else if (tsaffect () > 0)
        {
            affecte ();
            memo ();
        }

        else if (tstcom ("cd"))
        {
            sprintf (&chaine [pos + 1], "chd %s", &chaine [3]);
            system (&chaine [pos + 1]);

            strcpy (valdir, getcwd (0, 80));

            for (i = 0; valdir [i] != 0; i++)
            {
                if (valdir [i] == '\\')
                    valdir [i] = '/';
            }

            memo ();
        }

        /* commande unix standard (cas gnral) */
        else
        {
            testdate ();
            system (chaine);
            testdate ();
            memo ();
        }
    }

    /* si ligne vide, on retourne le prompt */
    else
        prompt ();

    /* mettre  blanc la fin du buffer clavier */
    for (i = pos; i <= 80; i++)
        clavier [i] = ' ';
}

/* slection d'une commande  partir de l'historique */
historique ()
{
    char i, j, val, trouve, select;


    /* test si rappel avec excution automatique */
    if (chaine [1] == carhist)
        autoexec = 1;
    else
        autoexec = 0;

    /* on se positionne aprs les caractres d'historique */
    chaine = chaine + autoexec + 1;
    nbcar = nbcar - autoexec - 1;

    /* cas particulier : traitement de la commande rappel */
    if (tstcom ("rappel"))
        rappel ();

    /* initialisation de la sauvegarde dans un fichier historique */
    else if (tstcom ("sauve"))
    {
        if (*fichist != 0)
            printf ("L'historique est dj sauvegard dans le fichier %s\n",
                                                                    fichist);
        else
        {
            chaine = chaine + 5;

            while (*chaine == ' ')
                chaine++;

            if (*chaine != 0)
            {
                sauvhist (chaine);
                majfichist ();
            }
            else
                puts ("Il faut prciser le nom du fichier historique");
        }

        prompt ();
    }

    /* rcupration d'un fichier historique */
    else if (tstcom ("recup"))
    {
        chaine = chaine + 5;

        while (*chaine == ' ')
            chaine++;

        if (*chaine != 0)
            recuphist (chaine);
        else
            puts ("Il faut prciser le nom du fichier historique  charger");

        prompt ();
    }

    /* suppression de la sauvegarde de l'historique dans un fichier */
    else if (tstcom ("suphist"))
    {
        if (*fichist != 0)
            *fichist = 0;
        else
            puts ("L'historique n'tait sauvegard dans aucun fichier");

        prompt ();
    }

    /* effacement complet de l'historique mmoris*/
    else if (tstcom ("nettoie"))
    {
        nbmemo = 0;
        pospred = 0;
        prompt ();

        /* effacement dans le fichier historique */
        if (*fichist != 0)
            majfichist ();
    }

    /* mmorisation du rpertoire courant */
    else if (tstcom ("memdir"))
        memodir ();

    /* repositionnement sur le rpertoire mmoris */
    else if (tstcom ("resdir"))
        restordir ();

    /* initialisation de l'option de traitement des accents */
    else if (tstcom ("accent"))
    {
        accent = 1;
        prompt ();
    }

    /* suppression de l'option de traitement des accents */
    else if (tstcom ("noaccent"))
    {
        accent = 0;
        prompt ();
    }


    /* cas gnral */
    else
    {
        /* si reprage par rapport  un numro de commande */
        if ((chaine [0] > '0') && (chaine [0] <= '9'))
        {
            /* rcuprer ce numro */
            val = chaine [0] - '0';

            if ((chaine [1] >= '0') && (chaine [1] <= '9'))
                val = (val * 10) + (chaine [1] - '0');

            /* test de dbordement */
            if (val > nbmemo)
            {
                printf ("dsol, pas assez de commandes mmorises\n");
                trouve = 0;
            }
            else
            {
                /* positionnement sur la commande slectionne */
                select = pospred - val + 1;

                if (select < 0)
                    select = select + 19;

                trouve = 1;
            }
        }
        /* sinon recherche par rapport  une abrviation */
        else
        {
            trouve = 0;

            select = pospred;

            /* tanque abrviation non trouve et il reste des commandes */
            for (i = 1; i <= nbmemo && trouve == 0; i++)
            {
                trouve = 1;

                /* si la commande ne contient pas l'abrviation */
                for (j = 0; chaine [j] != 0 && trouve == 1; j++)
                    if ((chaine [j] | ' ') != (chpred [select][j] | ' ')
                                                 || j >= szpred [select])
                        trouve = 0;

                /* passer  la commande suivante */
                if (trouve == 0)
                {
                    if (select == 0)
                        select = 19;
                    select--;
                }
            }

            if (trouve == 0)
                printf ("abrviation non mmorise\n");
        }

        /* si la commande a t trouve */
        if (trouve == 1)
        {
            /* l'diter  l'cran */

            affcom (select, 80);

            /* charger le buffer clavier avec cette commande */
            pos = szpred [select];

            for (i = 0; i < pos ; i++)
                clavier [i] = chpred [select][i];

            /* initialiser la fin du buffer clavier */
            for (i = pos; i < 80; i++)
                clavier [i] = ' ';

            /* excuter la commande ou se contenter de l'afficher */
            if (autoexec == 1)
            {
                putchar (EOL);
                execom ();
            }
            else
                putchar (CR);
        }
        /* commande non trouve, on raffiche le prompt */
        else
            prompt ();
    }
}

/* mmorisation du rpertoire courant */
memodir ()
{
    int i;


    strcpy (memdir, getcwd (0, 80));
    memdsk = getdisk ();

    for (i = 0; memdir [i] != 0; i++)
    {
        if (memdir [i] == '\\')
            memdir [i] = '/';
    }

    prompt ();
}




/* repositionnement sur le rpertoire mmoris */
restordir ()
{
    if (*memdir != 0)
    {
        setdisk (memdsk);
        strcpy  (valdir, memdir);
        chdir   (valdir);
        puts    (valdir);

        /* mettre  jour si ncssaire le fichier historique */
        if (*fichist != 0)
            majfichist ();
    }
    else
        puts ("Aucun rpertoire mmoris");

    prompt ();
}

/* remplacement du caractre carfin par sa valeur */
trtcarfin ()
{
    int i, szligp;

    /* rcupration de la taille de la commande prcdente */
    szligp = szpred [pospred];

    /* positionnement sur l'argument destin  remplacer carfin */
    for (i = 0; i < szligp && chpred [pospred][i] != ' '; i++);

    while (chpred [pospred][++i] == ' ');

    pos--;

    /* remplacement de carfin */
    while (i < szligp && pos < 80)
        clavier [pos++] = chpred [pospred][i++];

    clavier [pos] = 0;

    /* dition de la commande gnre */
    for (i = 0; clavier [i] != 0; i++)
        putchar (clavier [i]);

    crlf ();
}

/* rappel des dernires commandes excutes */
rappel ()
{
    char i, j;    /* compteurs */


    /* cas particulier : mode page demand mais interdit */
    if (autoexec == 1 && ansi == 0)
    {
        puts ("Pilote ansi.sys non install, pas de passage en mode page");
        autoexec = 0;
        putchar (7);
    }

    /* positionnement sur la dernire commande mmorise */
    j = pospred;

    crlf ();

    /* dition des commandes */
    for (i = 1; i <= nbmemo; i++)
    {
        /* l'dition peut se faire avec ou sans le numro de la commande */
        if (autoexec == 0)
        {
            printf ("%2d ", i);
            affcom (j, 77);
        }
        else
            affcom (j, 80);

        crlf ();

        /* passage  la commande prcdente */
        if (j == 0)
            j = 19;

        j--;
    }

    /* fin de l'dition */
    if (autoexec == 0)
    {
        crlf ();
        prompt ();
    }
    else
        printf ("\n[A");
}

/* affichage d'une commande mmorise */
affcom (select, max)
char select, max;
{
    char i, fin;
    unsigned char carac;

    /* rcupration du nombre de caractres de la commande */
    fin = szpred [select];

    if (max < fin)
        fin = max;

    /* dition de la commande */
    for (i = 0; i < fin; i++)
    {
        /* rcupration d'un caractre */
        carac = chpred [select][i];

        /* dition des caractres de controle, selons le contexte */
        if (carac < ' ')
        {
            if (max < 80)
            {
                putchar ('^');
                putchar (carac + '@');
            }
            else
                putchar ('?');
        }

        /* dition d'un caractre classique */
        else
            putchar (carac);
    }
}

/* affectation d'une variable */
affecte ()
{
    char nomvar [16];   /* nom de la variable d'environnement */
    char *affectation;  /* variable d'environnement avec sa valeur */
    int i;              /* compteur */

    /* rcuprer le nom de la variable */
    for (i = 0; i < 15 && chaine [i] != '='; i++)
        nomvar [i] = chaine [i];

    nomvar [i] = 0;

    /* traitement des variables prdfinies */

    if (strcmp (nomvar, "carhist") == 0)
        carhist = chaine [i + 1];

    else if (strcmp (nomvar, "carfin") == 0)
        carfin = chaine [i + 1];

    else if (strcmp (nomvar, "alarme") == 0)
        attente_car = atol (&chaine [i + 1]) * topmin;

    else if (strcmp (nomvar, "PS1") == 0)
    {
        sprintf (PS1, "%s", &chaine [i + 1]);
        majprompt ();
    }

    /* mise  jour de l'environnement du shell */
    affectation = malloc (nbcar + 1);
    memcpy (affectation, chaine, nbcar + 1);
    putenv (affectation);
}

/* archivage de la commande que l'on vient d'excuter */
memo ()
{
    int i;


    /* diter le prompt */
    prompt ();

    if (nbmemo < 19)
        nbmemo++;

    /* calcul de l'emplacement pour l'archivage */
    pospred = (pospred + 1) % 19;

    /* archivage du nombre de caractres */
    szpred [pospred] = nbcar;

    /* archivage de la commande */
    for (i = 0; i < nbcar; i++)
        chpred [pospred][i] = chaine [i];

    /* mettre  jour si ncssaire le fichier historique */
    if (*fichist != 0)
        majfichist ();
}

/* mise  jour du fichier historique */
majfichist ()
{
    FILE *ecrfichist;  /* descripteur du fichier historique en criture */
    char i, j;         /* compteurs */


    /* ouvrir en criture le fichier fichist */
    ecrfichist = fopen (fichist, "wb");

    /* sauvegarde des divers lments de l'historique */
    if (ecrfichist != 0)
    {
        /* caractres de reconnaissance */
        putc (carhist, ecrfichist);
        putc (carfin,  ecrfichist);

        /* rpertoire courant */
        for (i = 0; valdir [i] != 0; i++)
            putc (valdir [i], ecrfichist);

        putc (0, ecrfichist);

        /* prompt */
        for (i = 0; PS1 [i] != 0; i++)
            putc (PS1 [i], ecrfichist);

        putc (0, ecrfichist);

        /* historique des commandes */
        if (nbmemo > 0)
        {
            /* initialisation */
            if (nbmemo == 19)
                i = pospred;
            else
                i = 0;

            /* sauvegarde de l'historique */
            do
            {
                /* positionnement sur la commande  sauver */
                i = (i + 1) % 19;

                /* sauvegarde de la taille de la commande */
                j = szpred [i];
                putc (j, ecrfichist);

                /* et de son contenu */
                while (j-- > 0)
                    putc (chpred [i][j], ecrfichist);
            }
            while (i != pospred);
        }

        /* fin de l'historique */
        putc (0, ecrfichist);

        /* on libre le fichier historique */
        fclose (ecrfichist);
    }
    else
    {
        puts ("Fichier historique non accessible en criture");
        *fichist = 0;
    }
}

/* test des premiers caractres de la commande introduite */
int tstcom (com)
char com [];
{
    int i, test;

    /* initialisation */
    i = 0;
    test = 1;

    /* comparaison des caractres jusqu' la premire diffrence */
    do
    {
        if (com [i] != (chaine [i] | ' '))
            test = 0;
    }
    while (test == 1 && com [++i] != 0);

    /* test complmentaire en fin de chaine */
    if (i < nbcar && chaine [i] != ' ')
        test = 0;

    /* renvoi du rsultat du test */
    return (test);
}

/* vrifier si l'on doit traiter une commande d'affectation */
int tsaffect ()
{
    int i, test;

    /* initialisation */
    i = 0;
    test = 0;

    /* parcourir la commande introduite jusqu' la fin du premier argument */
    for (i = 0; (i < nbcar) && (test == 0); i++)
    {
        /* s'il est suivi de '=' c'est une affectation */
        if (chaine [i] == '=')
            test = 1;

        else if (chaine [i] == ' ')
            test = -1;
    }

    /* renvoi du rsultat du test */
    return (test);
}

/* initialisation ou mise  jour du prompt */
majprompt ()
{
    char i;

    /* on vrifie si le prompt contient des fonctions  interprter */
    varprompt = 0;

    for (i = 0; (PS1 [i] != 0) && (i < 80); i++)
    {
        /* si c'est le cas */
        if (PS1 [i] == '`')
        {
            varprompt = 1;

            /* fabriquer la commande d'dition du prompt */
            sprintf (affps1, "echo %s", PS1);

            /* vrification termine */
            i = 80;
        }
    }
}




/* dition du prompt */
prompt ()
{
    /* selons le prompt, on dite une chaine ou on excute une commande echo */
    if (varprompt == 0)
        puts (PS1);
    else
        system (affps1);

    /* passage  la ligne et vidage du buffer */
    putchar (CR);

    fflush (stdout);
}

/* attente d'un caractre au clavier et lecture */
int leccar ()
{
    long finattente;
    long freq;
    int  term;
    int  i;


    if (attente_car != 0)
    {
        finattente = clock () + attente_car;

        while (kbhit () == 0)
        {
            if (clock () > finattente)
            {
                testdate ();

                freq = freq_deb;
                term = freq_deb;

                for (i = 0; i < 3; i++)
                {
                    if (i >= 2)
                        term = freq_fin;

                    delai (0);  /* pour retalonner */

                    while (freq < freq_max && kbhit () == 0)
                    {
                        sound (freq);
                        delai (10);
                        freq = (freq << 6) / 63;
                    }
                    while (freq > term && kbhit () == 0)
                    {
                        sound (freq);
                        delai (10);
                        freq = (freq * 63) >> 6;
                    }
                }

                nosound ();

                finattente = finattente + attente_car;
            }

            delai (50);
        }
    }

    return (getch ());
}

/* temporisation en millisecondes */
delai (duree)
unsigned duree;
{
    static long pas_etalon = 0;
    long pas_avant_tic;
    long pas_restants;
    long der_heure;
    unsigned ecoule;


    if (duree == 0 || pas_etalon == 0)
    {
        pas_avant_tic = 0;

        der_heure = clock ();

        do
            pas_avant_tic ++;
        while (der_heure == clock ());

        der_heure ++;
        pas_etalon = 0;

        do
            pas_etalon ++;
        while (der_heure == clock ());

        ecoule = 55 + (55 * pas_avant_tic / pas_etalon);

        if (duree > ecoule)
            duree = duree - ecoule;
        else
            duree = 0;
    }

    pas_restants = duree * pas_etalon / 55;

    while (pas_restants-- > 0)
        der_heure = clock ();
}

/* correction de la date si dfaillance du systme */
testdate ()
{
    memcpy (&dateref, &datecur, sizeof (struct date));
    memcpy (&heuravant, &heurapres, sizeof (struct time));
    clockavant = clockapres;

    getdate (&datecur);
    gettime (&heurapres);
    clockapres = clock ();

    if (heurapres.ti_hour < heuravant.ti_hour &&
        dateref.da_day == datecur.da_day &&
       (clockapres - clockavant > 5000 ||
        heurapres.ti_hour + 23 <= heuravant.ti_hour))
    {
        puts ("Correction de la date");

        datecur.da_day = datecur.da_day + 1;

        setdate (&datecur);
        getdate (&datecur);

        if (dateref.da_day == datecur.da_day)
        {
            datecur.da_day = 1;

            if (datecur.da_mon == 12)
            {
                datecur.da_mon = 1;
                datecur.da_year = datecur.da_year + 1;
            }
            else
                datecur.da_mon = datecur.da_mon + 1;

            setdate (&datecur);
        }
    }
}

/* aide sur l'utilisation de l'outil */
aide ()
{
    int n;   /* slection de l'oprateur */


    /* afficher le menu de la documentation */
    if (message (0) > 0)
    {
        /* lire et mmoriser le choix de l'oprateur */
        n = leccar ();

        /* affichage de la rponse oprateur */
        putchar (n);

        /* remise en forme de la rponse oprateur */
        n = n - '0';

        /* afficher la page de documentation slectionne */
        if (n > 0 && n <= 9)
        {
            puts ("\n\n");
            message (n);
        }
        else
            puts ("  Erreur !\r");
    }

    /* on affiche le prompt */
    prompt ();
}

/* affichage d'une page de la documentation en ligne */
int message (n)
int n;
{
    FILE *aide;   /* descripteur du fichier d'aide en ligne */
    char car;     /* caractre du fichier d'aide en ligne */


    /* ouvrir le fichier d'aide en ligne */
    aide = fopen (ficaide, "rb");

    /* si l'ouverture s'est bien passe */
    if (aide > 0)
    {
        /* se positionner sur la page  afficher */
        while (n > 0)
        {
            car = getc (aide);

            if (car == CTRL)
                n--;
        }

        /* lire le caractre suivant */
        car = getc (aide);

        /* afficher la page */
        while ((car != CTRL) && (car != EOF))
        {
            /* traitement spcial pour diter le caractre carhist ou carfin */
            if (car == '~')
            {
                car = getc (aide);

                if (car == '!')
                    putchar (carhist);

                else if (car == '@')
                    putchar (carfin);
                else
                    putchar (car);
            }

            /* traitement du dlimiteur de page d'cran */
            else if (car == 0)
            {
                printf ("Appuyer sur une touche pour continuer");

                leccar ();

                putchar (CR);

                if (ansi == 1)
                    putseq ('K');

                putchar (8);
            }

            /* traitement d'un passage  la ligne */
            else if (car == EOL)
                crlf ();

            /* dition d'un caractre normal */
            else
                putchar (car);


            /* lire le caractre suivant */
            car = getc (aide);
        }

        /* librer le fichier d'aide en ligne */
        fclose (aide);
        return (1);
    }

    /* sinon message d'erreur */
    else
    {
        puts ("Fichier d'aide en ligne manquant\r");
        return (0);
    }
}

/* vrification de la prsence du pilote ansi.sys et installation ventuelle */
testansi ()
{
    putseq ('K');

    if (wherex () == 1)
        ansi = 1;
    else
    {
        ansi = 0;
        puts ("\rPilote ansi.sys non install, fonctionnement dgrad");
        putchar (7);   /* bip */

        system ("addansi");
    }
}

/* dition d'un passage  la ligne */
crlf ()
{
    putchar (EOL);
    putchar (CR);
}


/* dition d'une squence escape */
putseq (car)
char car;
{
    putchar (ESC);
    putchar ('[');
    putchar (car);
}


/* effacement du bas de page */
clrfin ()
{
    char y, suiv;

    putseq ('K');

    y = wherey ();
    suiv = y;

    while (suiv++ < 25)
    {
        putchar (EOL);
        putseq ('K');
    }

    gotoxy (1, y);
}



/* rappel syntaxe de la commande aprs une erreur sur les paramtres d'appel */
psyntaxe (varg)
char *varg;
{
    /* diter un message d'erreur */
    printf ("          Option %s incorrecte\n\n", varg);

    /* rappeler les paramtre d'appel */
    message (2);

    /* sortir du programme */
    exit (0);
}
