#include <stdio.h>

#define szmaxlig  256
#define nbmaxzone  50


main (narg, varg)
int narg;
char *varg [];
{
    char *carg;
    int car, pdeb, pfin;
    unsigned char pos, deb [nbmaxzone], fin [nbmaxzone], ligne [szmaxlig];
    char zone, nbzones;


    nbzones = 0;

    *varg++;
    narg--;
    carg = *varg;

    if ((*carg++ == '-') && (*carg++ == 'c'))
    {
        while (*carg != 0)
        {
            pdeb = 0;

            while ((*carg >= '0') && (*carg <= '9'))
            {
                pdeb = (pdeb * 10) + *carg - '0';
                carg++;
            }

            if (pdeb < szmaxlig)
                deb [nbzones] = pdeb;
            else
            {
                fprintf (stderr, "%d : %s %d caracteres\n", pdeb,
                "Valeur hors limite, rcut ne traite que", szmaxlig - 1);
                exit ();
            }

            if (*carg == '-')
            {
                carg++;

                if (*carg != 0)
                {
                    pfin = 0;

                    while ((*carg >= '0') && (*carg <= '9'))
                    {
                        pfin = (pfin * 10) + *carg - '0';
                        carg++;
                    }

                    if (pfin >= pdeb)
                        if (pfin < szmaxlig)
                            fin [nbzones++] = pfin;
                        else
                        {
                            fprintf (stderr, "%d : %s %d caracteres\n", pfin,
                      "Valeur hors limite, rcut ne traite que", szmaxlig - 1);
                            exit ();
                        }
                    else
                    {
                        fprintf (stderr, "intervalle : %u-%u incorrect\n",
                                 pdeb, pfin);
                        exit ();
                    }
                }
                else
                    fin [nbzones++] = -1;
            }
            else if ((*carg == ',') || (*carg == 0))
                fin [nbzones++] = pdeb;

            else
                psyntaxe ();

            if (*carg == ',')
                carg++;
            else if (*carg != 0)
                psyntaxe ();
        }
    }
    else
        psyntaxe ();

    *varg++;
    narg--;

    do
    {
        if (narg > 0)
        {
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        car = getchar ();

        while (car != EOF)
        {
            pos = 0;

            while ((car != '\n') && (car != EOF) && (pos < szmaxlig - 1))
            {
                ligne [++pos] = car;
                car = getchar ();
            }

            while ((car != '\n') && (car != EOF))
                car = getchar ();

            for (zone = 0; zone < nbzones; zone++)
            {
                pdeb = deb [zone];
                pfin = fin [zone];

                if (pfin > pos)
                    pfin = pos;

                while (pdeb <= pfin)
                    putchar (ligne [pdeb++]);
            }

            putchar ('\n');

            car = getchar ();
        }

        *varg++;
        narg--;
    }
    while (narg > 1);
}


psyntaxe ()
{
     fprintf (stderr, "%s\n\n%s\n%s\n",
             "Syntaxe : rcut -c<liste d'intervalles> <liste de fichiers>",
             "          <liste d'intervalles> = <intervalle>(,<intervalle>)*",
             "          <intervalle> = <nombre>[-<nombre>]");

     exit ();
}
