#include <stdio.h>

/* caractre lu dans le fichier */
static int car;

/* nombre de caractres de chaque catgorie */
static unsigned char nbcarnor, nbcarspe;

/* taille minimale des chaines  editer */
static int nbcarmin;



/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    /* se positionner sur un argument */
    varg++;
    narg--;

    /* rcupration de la taille minimale des chaines accepte */
    if (narg > 0 && **varg == '-')
    {
        nbcarmin = - atoi (*varg);

        if (nbcarmin > 0)
        {
            /* passer  l'argument suivant */
            varg++;
            narg--;
        }
        else
        {
            fputs ("Syntaxe : strings [-<taille mimimale chaine>] [<fichiers>]\n"
                                                                   , stderr);
            exit (-1);
        }
    }
    else
        nbcarmin = 1;

    /* rpter */
    do
    {
       /* si argument pass en paramtre */
        if (narg > 0)
        {
            /* ouvrir le fichier correspondant */
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        /* se positionner sur la premire chaine de caractres */
        rechdeb ();

        /* diter les chaines de caractres du fichier */
        affchaines ();

        /* passer  l'argument suivant */
        varg++;
        narg--;
     }
    /* jusque plus d'argument  traiter */
    while (narg > 0);
}

/* indique si le dernier caractre lu fait
   partie du jeu de caractres des chaines */
int carchaine (car)
int car;
{
    return ((car >= ' ' && car <= 0x8A) || car == '\n');
}


/* positionnement sur la premire chaine de caractres du fichier */
rechdeb ()
{
    /* initialisation */
    nbcarnor = 0;
    nbcarspe = 0;

    car = getchar ();

    /* tantqu'on n'a pas trouv de chaine contenant au moins 20
       caractres du jeu prdfini pour maximum 2 autres caractres  */
    while (car != EOF && nbcarnor < 20)
    {
        /* compter les caractres du jeu prdfini */
        if (carchaine (car))
            nbcarnor++;

        /* si fin de chaine, on recommence le comptage */
        else if (car == 0)
        {
            nbcarnor = 0;
            nbcarspe = 0;
        }
        /* si le caractre n'est pas du jeu prdfini */
        else
        {
            /* s'il n'y pas trop de caractres semblables */
            if (nbcarspe < 2)
                /* comptabiliser ce caractre */
                nbcarspe++;
            else
            {
                /* sinon (chaine refuse) recommencer un comptage */
                nbcarnor = 0;
                nbcarspe = 1;
            }
        }

        /* lire le caractre suivant */
        car = getchar ();
    }

    /* se positionner au dbut de la chaine trouve */
    fseek (stdin, - nbcarnor - nbcarspe - 1, 1);
}

/* dition des chaines de caractres du fichier */
affchaines ()
{
    /* tantque non fin de fichier */
    while (car != EOF)
    {
        /* lire le caractre sur lequel on est positionn */
        car = getchar ();

        /* tantque non fin de chaine ni de fichier */
        while (car != 0 && car != EOF)
        {
            /* diter les caractres de la chaine */
            if (car != '\n')
            {
                if (car < ' ' && car != '\r')
                {
                    /* les caractres de controle sont affichs en clair */
                    putchar ('^');
                    putchar (car | '@');
                }
                else
                    putchar (car);

                car = getchar ();
            }
            /* un passage  la ligne en fin de chaine est ignor */
            else
            {
                car = getchar ();

                if (car != 0)
                    putchar ('\n');
            }
        }

        /* la chaine est edite, on passe  la ligne */
        putchar ('\n');

        /* rpter */
        do
        {
            /* sauter les caractres de sparation de chaines */
            while (car == 0)
                car = getchar ();

            /* initialisation des compteurs */
            nbcarnor = 0;
            nbcarspe = 0;

            /* tantque non fin de chaine et non fin de fichier */
            while (car != 0 && car != EOF)
            {
                /* comptabiliser le caractre courant dans sa catgorie */
                if (carchaine (car))
                    nbcarnor++;
                else
                    nbcarspe++;

                /* lire le caractre suivant */
                car = getchar ();
            }
        }
        /* jusque on a trouv une chaine assez longue ou fin de fichier */
        while (((nbcarspe * 4 >= nbcarnor) ||
                (nbcarspe + nbcarnor < nbcarmin)) && car != EOF);

        /* si non fin de fichier */
        if (car != EOF)
            /* se positionner sur la chaine trouve */
            fseek (stdin, - nbcarnor - nbcarspe - 1, 1);
    }
}