#include <stdio.h>
#include <alloc.h>

static long nblig = 10;
static long nlig;
static int  car;


main (narg, varg)
int narg;
char *varg [];
{
    char *carg;


    if (--narg > 0)
    {
         varg ++;
         carg = *varg;

         if (*carg == '-')
         {
              nblig = 0;
              carg++;

              while ((*carg >= '0') && (*carg <= '9'))
              {
                   nblig = (nblig * 10) + *carg - '0';
                   carg++;
              }

              if (*carg != 0)  psyntaxe ();

              narg --;
              varg++;
         }
    }

    if (narg == 0)
        tailpipe ();

    else if (narg == 1)
        tailfich (*varg);
    else
        psyntaxe ();
}



psyntaxe ()
{
     fprintf (stderr,
              "Syntaxe : tail [-<nombre de lignes>] [<nom de fichier>]\n");
     exit ();
}

tailpipe ()
{
    char fictmp [] = "c:/tmp/tail";
    char *buffer;
    unsigned int posbuf, derpos, nbcar, szbuf;
    char retour;
    FILE *tmp;


    if (nblig > 500)
    {
        tmp = fopen (fictmp, "wb");

        car = getchar ();

        while (car != EOF)
        {
            putc (car, tmp);
            car = getchar ();
        }

        fclose (tmp);

        tailfich (fictmp);

        unlink (fictmp);
    }
    else
    {
        if (coreleft () & 0xff0000)
            szbuf = 0xFFFF;
        else
            szbuf = coreleft () - 10;

        buffer = malloc (szbuf);
        posbuf = 1;
        retour = 0;

        car = getchar ();

        while (car != EOF)
        {
            if (posbuf == szbuf)
            {
                retour = 1;
                posbuf = 0;
            }

            buffer [posbuf++] = car;

            car = getchar ();
        }

        if (retour == 0)
            derpos = 0;
        else
            derpos = posbuf;

        posbuf --;

        nlig = 0;

        if (buffer [posbuf] == '\n')
            nbcar = 0;
        else
            nbcar = 1;

        while ((nlig < nblig) && (posbuf != derpos))
        {
            if (posbuf == 0)
                posbuf = szbuf;

            posbuf --;
            nbcar ++;

            if (buffer [posbuf] == '\n')
                nlig ++;
        }

        while (nbcar -- > 0)
        {
            posbuf ++;

            if (posbuf == szbuf)
                posbuf = 0;

            putchar (buffer [posbuf]);
        }

        if (buffer [posbuf] != '\n')
            putchar ('\n');
    }
}

tailfich (varg)
char *varg;
{
    int  cpred;
    long pos, pospred, i;
    FILE *adrfc;

    adrfc = fopen (varg, "rb");

    if (adrfc == 0)
    {
         fprintf (stderr, "Fichier %s inexistant\n", *varg);
         exit ();
    }

    fseek (adrfc, -1, 2);

    if (getc (adrfc) == '\n')
        nlig = 0;
    else
        nlig = 1;

    pos = ftell (adrfc);

    while ((nlig <= nblig) && (pos > 0))
    {
        pospred = pos;

        pos = pos - ((nblig - nlig + 1) * 40);

        if (pos < 0)
            pos = 0;

        fseek (adrfc, pos, 0);

        for (i = pos; i < pospred; i++)
        {
            car = getc (adrfc);

            if (car == '\n')
                nlig++;
        }
    }

    fseek (adrfc, pos, 0);

    while (nlig > nblig)
    {
        car = getc (adrfc);

        if (car == '\n')
            nlig--;
    }

    car = getc (adrfc);

    while (car != EOF)
    {
        putchar (car);

        cpred = car;

        car = getc (adrfc);
    }

    if (cpred != '\n')
        putchar ('\n');

    close (adrfc);
}