#include <stdio.h>

#define LF  10
#define CR  13


main (narg, varg)
int narg;
char *varg [];
{
    char fictmp [6];
    FILE *ficin, *ficout;
    int  car;
    int  errcopie;


    if (narg > 1)
    {

        do
        {
            varg++;
            narg--;

            ficin = fopen (*varg, "rb");

            if (ficin == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
            else
            {
                strcpy (fictmp, "./{-}");

                if (varg [0][1] == ':')
                {
                    fictmp [0] = varg [0][0];
                    fictmp [1] = ':';
                }

                ficout = fopen (fictmp, "wb");

                if (ficout == 0)
                {
                    fprintf (stderr,
                          "Impossible de convertir le fichier %s\n", *varg);
                    exit ();
                }

                errcopie = 0;
                car = getc (ficin);

                while ((car != EOF) && (errcopie == 0))
                {
                    if ((car == CR) || (car == LF))
                        if (putc (CR, ficout) != CR)
                            errcopie = 1;

                    if (putc (car, ficout) != car)
                        errcopie = 1;

                    car = getc (ficin);
                }

                fclose (ficin);
                fclose (ficout);

                if (errcopie == 0)
                {
                    unlink (*varg);
                    rename (fictmp, *varg);
                }
                else
                {
                    fprintf (stderr,
             "Manque d'espace disque pour convertir le fichier %s\n", *varg);

                    unlink (fictmp);
                }
            }
        }
        while (narg > 1);
    }
    else
        fputs ("Syntaxe : unix-dos <nom ou liste de fichier (s)>\n", stderr);
}
