#include <stdio.h>
#include <stdlib.h>


/* noms des fichiers utiliss */
static char *chemfich;
static char nombak  [13];
static char chembak [80];
static char chembak2 [80];

/* programme principal */

main (narg, varg)
int narg;
char *varg [];
{
    FILE *ficin, *ficout;
    int car;
    char *varenv;
    char *carcur, *cardeb;
    int posdercar;
    int i;


    /* Test de la prsence de sauvegardes lors de l'appel de ..vi.. */
    varenv = getenv ("BAKDIR");

    if (varenv || getenv ("NBBAK"))
    {
        /* controle du nombre de fichiers passs en paramtre */
        if (narg == 2)
        {
            /* nom du fichier */
            chemfich = varg [1];

            /* rcupration du rpertoire de sauvegarde */
            if (varenv)
            {
                strcpy (chembak, varenv);

                carcur = chembak + strlen (chembak) - 1;

                if (*chembak && *carcur != '\\' && *carcur != '/')
                {
                    carcur ++;

                    *carcur = '/';
                    *(carcur + 1) = 0;
                }
            }
            else
                *chembak = 0;

            /* rcupration du nom du fichier sans le chemin d'accs */
            carcur = chemfich;
            cardeb = carcur;

            while (*carcur != 0)
            {
                if (*carcur == '\\' || *carcur == '/')
                    cardeb = ++carcur;
                else
                    carcur ++;
            }

            strcpy (nombak, cardeb);

            /* fabrication de la version prcdente du nom du fichier */
            carcur = nombak + 1;

            while (*carcur != '.' && *carcur != 0)
                carcur ++;

            for (i = 0; *carcur != 0; i++)
                carcur ++;

            switch (i)
            {
                case 0 : *(carcur ++) = '.';
                         break;

                case 4 : carcur --;
            }

            *carcur = '1';
            *(carcur + 1) = 0;

            strcat (chembak, nombak);
            strcpy (chembak2, chembak);

            posdercar = strlen (chembak2) - 1;

            if (access (chembak, 0) == 0)
            {
                unlink (chemfich);

                if (rename (chembak, chemfich) != 0)
                {
                    ficin  = fopen (chembak, "rb");
                    ficout = fopen (chemfich, "wb");

                    if (ficout)
                    {
                        car = getc (ficin);

                        while (car != EOF)
                        {
                            putc (car, ficout);
                            car = getc (ficin);
                        }

                        fclose (ficin);
                        fclose (ficout);

                        unlink (chembak);
                    }
                    else
                        fprintf (stderr, "Fichier %s protg ou inacessible\n",
                                                                    chemfich);
                }

                do
                {
                    chembak2 [posdercar] = chembak [posdercar];

                    if (chembak [posdercar] == '9')
                        chembak [posdercar] = 'A';
                    else
                        chembak [posdercar] = chembak [posdercar] + 1;
                }
                while (rename (chembak, chembak2) == 0);
            }
            else
                fprintf (stderr, "Le fichier %s n'a pas t sauvegard\n",
                                                                  chemfich);
        }
        else
            fputs ("Syntaxe : unsave <nom de fichier>\n", stderr);
    }
    else
        fputs ("Il n'y a pas de sauvegardes faites lors des appels de vi\n",
                                                                     stderr);
}
