/*
       Gestion de l'affichage des programmes vi, gvi et mxvi
*/

#ifndef globales
#include "globvi.c"
#endif


/* prototype */
positionner (intxx);


message (chaine)
char *chaine;
{
    sauveposit ();

    baspage ();

    printf (chaine);

    restorposit ();

    bip ();
}




/*
razecran ()
{
    octet teintes;

    textmode (confecran.currmode);

    teintes = ((confecran.attribute & 0x11) << 2) |
               (confecran.attribute & 0x22) |
              ((confecran.attribute & 0x44) >> 2);
    printf ("%c[3%dm%c[4%dm", ESC, teintes & 0x7, ESC, teintes >> 4);

    if (confecran.attribute & 0x08)
        printf ("%c[1m", ESC);
}     */

/*  Procdures de dplacement dans le fichier */

avance (depl)
int16 depl;
{
    int16 colonne;


    if (resyncbuf == 1)
        synchrobuf ();

    colonne = decald + colcurseur;

    while (depl > 0)
    {
        if (carcourant () != EOL && ! finfichier ())
        {
            if (carcourant () < ' ')
            {
                if (carcourant () == TAB)
                    do
                        colonne ++;
                    while ((colonne & 7) != coldeblig);
                else
                    colonne = colonne + 2;
            }
            else
                colonne ++;

            avancebuf ();
            depl--;
        }
        else
        {
            colonne = colonne + depl;
            apresfinlig = apresfinlig + depl;
            depl = 0;
        }
    }

    if (colonne - decald > colonecran - 1)
    {
        decald = ((colonne - colonecran) / stepdecald + 1) * stepdecald;
        reaffiche ();
        resyncbuf = 1;
    }

    poscurseur (lignecurseur, colonne - decald);
}

recule (depl)
int16 depl;
{
    int16 colonne;


    if (resyncbuf == 1)
        synchrobuf ();

    colonne = decald + colcurseur;

    while (depl > 0 && colonne > coldeblig && ! debfichier ())
    {
        if (apresfinlig > 0)
        {
            colonne --;
            apresfinlig --;
        }
        else
        {
            reculebuf ();

            if (carcourant () < ' ')
                colonne = colonne - 2;
            else
                colonne --;
        }

        depl--;
    }

    if (depl > 0)
    {
        bip ();
        supcarid ();
    }

    if (decald > 0 && colonne < decald + coldeblig + 1)
    {
        decald = ((colonne - coldeblig - 1) / stepdecald) * stepdecald;
        reaffiche ();
        resyncbuf = 1;
    }

    poscurseur (lignecurseur, colonne - decald);
}

monte (depl)
intxx depl;
{
    octet colonne;
    octet depassement;


    if (depl >= numlig)
    {
        depl = numlig - 1;
        depassement = 1;
    }
    else
        depassement = 0;

    colonne = colcurseur;
    posdeblig ();

    while (depl > 0 && lignecurseur > 1)
    {
        numlig --;
        putseq ("A");
        lignecurseur --;
        posfinligprec ();
        depl --;
    }

    if (depl > (numlig / 2) + lignecran)
    {
        depl = numlig - depl + (2 * (lignecran - 1));

        posdebuf ();
        numlig = 0;

        while (depl >= lignecran)
        {
            numlig++;
            posfinlig ();
            depl--;
        }
    }
    else
    {
        while (depl >= lignecran)
        {
            numlig--;
            posfinligprec ();
            depl--;
        }
    }

    while (depl > 0)
    {
        affligprec ();
        depl --;
    }

    if (depassement)
    {
        bip ();
        supcarid ();
    }

    /* correction si erreur de positionnement imprvue */
    if (lignecurseur > numlig)
        lignecurseur = numlig;

    poscurseur (lignecurseur, colonne);

    resyncbuf = 1;
}

descend (depl)
intxx depl;
{
    octet colonne;
    intxx decalbas;
    intxx i;


    colonne = colcurseur;

    posdeblig ();

    if (carcourant () != EOL)
        posfinlig ();

    while (depl > 0 && lignecurseur < lignecran - 1 && ! finfichier ())
    {
        putseq ("B");
        numlig ++;
        lignecurseur ++;
        posfinlig ();
        depl--;
    }

    decalbas = 0;

    while (depl > 0 && ! finfichier ())
    {
        numlig++;
        posfinlig ();
        depl--;
        decalbas ++;
    }

    if (decalbas >= lignecran)
        decalbas = lignecran - 1;

    for (i = 0; i < decalbas; i++)
    {
        posfinligprec ();
        numlig--;
    }

    for (i = 0; i < decalbas; i++)
    {
        putseq ("B");
        affligsuiv ();
    }

    if (lignecurseur == lignecran)
    {
        lignecurseur --;
        reaffmode = 1;
    }

    poscurseur (lignecurseur, colonne);

    if (depl > 0 && supbip == 0)
    {
        bip ();
        supcarid ();
    }

    resyncbuf = 1;
    supbip    = 0;
}

positlig (destination)
intxx destination;
{
    if (destination == 0)
    {
        positionner (1);
        debligne ();
    }
    else
    {
        positionner (destination);

        if (! finfichier ())
        {
            descend (1);
            debligne ();
        }
        else
            finligne ();
    }
}




positionner (destination)
intxx destination;
{
    restorposit ();
    debligne ();

    if (destination < numlig)
    {
        if (numlig - lignecurseur < destination)
            monte (numlig - destination);
        else
        {
            if (destination > 5)
            {
                monte (numlig - destination + 5);
                descend (5);
            }
            else
            {
                monte (numlig - 1);
                descend (destination - 1);
            }
        }
    }
    else if (destination > numlig)
    {
        if (numlig + lignecran - lignecurseur > destination)
            descend (destination - numlig);
        else
        {
            if (destination == nbmaxlig)
                supbip = 1;

            descend (destination - numlig);

            if (numlig == destination)
            {
                supbip = 1;

                descend (5);
                monte (numlig - destination);
            }
        }
    }
}

positbuf (destination)
intxx destination;
{
    if (destination > numlig)
    {
        if (carcourant () == EOL)
            numlig ++;

        while (destination > numlig && ! finfichier ())
        {
            posfinlig ();
            numlig ++;
        }

        if (! finfichier ())
            avancebuf ();

        else if (destination == numlig)
            posdeblig ();
    }
    else if (destination < numlig)
    {
        if (destination < (numlig / 2))
        {
            posdebuf ();
            numlig = 1;

            if (destination > 1)
            {
                while (destination > numlig)
                {
                    posfinlig ();
                    numlig ++;
                }

                avancebuf ();
            }
        }
        else
        {
            posdeblig ();

            do
            {
                posfinligprec ();
                numlig --;
            }
            while (destination < numlig);

            posdeblig ();
        }
    }
}

deplverslig (dest, orig)
intxx dest, orig;
{
    int i;


    sauveposbuf ();

    if (dest > orig)
    {
        while (lignecurseur < lignecran - 1 && dest > orig)
        {
            putseq ("B");
            lignecurseur ++;
            orig++;
        }

        if (dest > orig)
        {
            putseq ("B");

            for (i = 1; i < lignecran && numlig > orig; i++)
            {
                posfinligprec ();
                numlig --;
            }

            while (numlig < dest)
                affligsuiv ();

            for (i = 1; i < 5 && ! finfichier (); i++)
                affligsuiv ();

            lignecurseur = lignecurseur - i;
            numlig = numlig - i + 1;

            reaffmode = 1;
        }
    }
    else if (dest < orig)
    {
        while (lignecurseur > 1 && dest < orig)
        {
            putseq ("A");
            lignecurseur --;
            orig--;
        }

        if (dest < orig)
        {
            if (dest > 5)
                lignecurseur = 5;
            else
                lignecurseur = dest;

            if (carcourant () != EOL)
                posfinlig ();

            for (i = lignecurseur; i < lignecran && numlig < orig; i++)
            {
                posfinlig ();
                numlig ++;
            }

            while (numlig > dest)
                affligprec ();

            for (i = 1; i < lignecurseur; i++)
                affligprec ();

            numlig = numlig + lignecurseur - 1;
            reaffmode = 1;
        }
    }

    restorposbuf ();
}




premiercar ()
{
    int16 colonne;
    int16 pdecald;


    pdecald = decald;

    posdeblig ();

    colonne = coldeblig;

    while (carcourant () == ' ')
    {
        avancebuf ();
        colonne ++;
    }

    if (colonne <= colonecran)
    {
        decald = 0;
        colcurseur = colonne;
    }
    else
    {

    }

    if (decald != pdecald)
        reaffiche ();

    poscurseur (lignecurseur, colcurseur);
    resyncbuf = 0;
}




debligne ()
{
    posdeblig ();

    colcurseur = coldeblig;

    if (decald > 0)
    {
        decald = 0;
        reaffiche ();
    }

    poscurseur (lignecurseur, colcurseur);
    resyncbuf = 0;
}




finligne ()
{
    int16 colonne;
    int16 pdecald;


    pdecald = decald;

    posdeblig ();

    colonne = coldeblig;

    while (carcourant () != EOL && ! finfichier ())
    {
        if (carcourant () < ' ')
        {
            if (carcourant () == TAB)
                do
                    colonne ++;
                while ((colonne & 7) != coldeblig);
            else
                colonne = colonne + 2;
        }
        else
            colonne ++;

        avancebuf ();
    }

    decald = 0;

    while (colonne >= colonecran)
    {
        colonne = colonne - stepdecald;
        decald  = decald  + stepdecald;
    }

    colcurseur = colonne;

    if (decald != pdecald)
        reaffiche ();

    poscurseur (lignecurseur, colcurseur);
    resyncbuf = 0;
}




synchrobuf ()
{
    int16 offset, colonne;


    posdeblig ();

    offset = decald;

    while (offset > 0 && carcourant () != EOL && ! finfichier ())
    {
        avancebuf ();
        offset--;
    }

    colonne = coldeblig;

    while (colonne < colcurseur && carcourant () != EOL && ! finfichier ())
    {
        if (carcourant () < ' ')
        {
            if (carcourant () == TAB)
                colonne = (colonne & 0xF8) + 1;
            else
                colonne = colonne + 2;
        }
        else
            colonne ++;

        avancebuf ();
    }

    if (carcourant () == EOL)
        apresfinlig = colcurseur - colonne;
    else
        apresfinlig = 0;

    resyncbuf = 0;
}

synchrocol ()
{
    int16 colonne;


    posdeblig ();

    colonne = coldeblig;

    while (colonne < (colcurseur + decald) && carcourant () != EOL && ! finfichier ())
    {
        if (carcourant () < ' ')
        {
            if (carcourant () == TAB)
                do
                    colonne ++;
                while ((colonne & 7) != coldeblig);
            else
                colonne = colonne + 2;
        }
        else
            colonne ++;

        avancebuf ();
    }

    if (colonne <= colcurseur + decald)
        poscurseur (lignecurseur, colonne - decald);

    resyncbuf = 0;
}




syncolbuf ()
{
    int16 deplacement;
    int   colonne;


    if (! debfichier ())
    {
        deplacement = 0;

        do
        {
            reculebuf ();
            deplacement ++;
        }
        while (carcourant () != EOL && ! debfichier ());

        if (carcourant () == EOL)
        {
            avancebuf ();
            deplacement --;
        }

        colonne = coldeblig;

        while (deplacement-- > 0)
        {
            if (carcourant () < ' ')
            {
                if (carcourant () == TAB)
                    do
                        colonne ++;
                    while ((colonne & 7) != coldeblig);
                else
                    colonne = colonne + 2;
            }
            else
                colonne ++;

            avancebuf ();
        }
    }
    else
        colonne = coldeblig;

    if (colonne - decald < coldeblig || colonne - decald > colonecran)
    {
        if (colonne < colonecran)
            decald = 0;
        else
            decald = ((colonne - colonecran) / stepdecald + 1) * stepdecald;

        reaffiche ();
    }

    poscurseur (lignecurseur, colonne - decald);

    resyncbuf = 0;
}




reaffiche ()
{
    int y;


    sauveposit ();
    sauveposbuf ();

    y = lignecurseur;
    hautpage ();

    do
    {
        posfinligprec ();

        y --;
        numlig --;
    }
    while (y > 0);

    while (lignecurseur < lignecran)
        affligsuiv ();

    restorposbuf ();
    restorposit ();

    reaffpage = 0;
}




sauveposit ()
{
    savecol  = colcurseur;
    savelig  = lignecurseur;
    savenuml = numlig;
}




restorposit ()
{
    poscurseur (savelig, savecol);
    numlig = savenuml;
}

posdeblig ()
{
    if (! debfichier ())
    {
        posfinligprec ();

        if (carcourant () == EOL)
            avancebuf ();
    }
}




posfinligprec ()
{
    if (! debfichier ())
    {
        do
            reculebuf ();
        while (carcourant () != EOL && ! debfichier ());
    }
}




posfinlig ()
{
    if (! finfichier ())
    {
        do
            avancebuf ();
        while (! finfichier () && carcourant () != EOL);
    }
}




affligsuiv ()
{
    putchar (CR);

    numlig ++;

    if (carcourant () == EOL && ! finfichier ())
        avancebuf ();

    affligne ();

    if (colcurseur < colonecran)
        effligne ();

    if (carcourant () != EOL)
        posfinlig ();

    if (colcurseur <= colonecran)
        putchar (EOL);

    if (lignecurseur < lignecran)
        lignecurseur++;
    else
        reaffmode = 1;
}




affligprec ()
{
    posfinligprec ();
    posdeblig ();

    numlig --;

    inserligne ();

    if (colcurseur < colonecran)
        putchar (CR);
    else
        putseq ("H");

    affligne ();

    posdeblig ();

    reaffmode = 1;
}

affligne ()
{
    if (optescape != 0)
        putseq ("0m");

    affdeblig ();

    if (! finfichier ())
    {
        if (decald != 0)
        {
            affcar ('<');
            synchrobuf ();
        }

        affinlig ();
    }
    else
        putchar ('~');

    if (optescape == OPTPOLICE && colcurseur < colonecran)
        putseq ("0m");
}




affinlig ()
{
    while (carcourant () != EOL && colcurseur < colonecran && ! finfichier ())
    {
        if (carcourant () != ESC)
        {
            affcar (carcourant ());
            avancebuf ();
        }
        else
            trtescape ();
    }

    if (colcurseur == colonecran && carcourant () != EOL)
    {
        avancebuf ();

        if (carcourant () == EOL)
        {
            reculebuf ();

            if (carcourant () < ' ')
                putchar ('>');
            else
                putchar (carcourant ());
        }
        else
            putchar ('>');

        putseq ("A");
    }
}

affdeblig ()
{
    if (optnuml)
        affnumlig (' ');

    colcurseur = coldeblig;
}




affinuml ()
{
    sauveposit ();

    putchar (CR);

    while (lignecurseur++ < lignecran)
    {
        affnumlig ('\n');
        numlig ++;
    }

    restorposit ();
}




affnumlig (dercar)
char dercar;
{
#ifdef vi
    printf ("%5u", numlig);
    putchar (dercar);
#else
#ifdef gvi
    printf ("%5lu", numlig);

    if (numlig < 100000 || dercar != ' ')
        putchar (dercar);
#else
    printf ("%7lu", numlig);

    if (numlig < 10000000 || dercar != ' ')
        putchar (dercar);
#endif
#endif
}

affinpage ()
{
    sauveposit ();
    sauveposbuf ();

    effligne ();
    affinlig ();

    if (carcourant () != EOL)
        posfinlig ();

    if (colcurseur <= colonecran)
        putchar (EOL);

    lignecurseur ++;

    while (lignecurseur < lignecran)
        affligsuiv ();

    restorposbuf ();
    restorposit ();
}




affcar (car)
octet car;
{
    if (car == EOL)
    {
        if (lignecurseur++ < lignecran - 1)
        {
            putchar (EOL);
            numlig ++;
            affdeblig ();
        }

        effligne ();
    }
    else if (colcurseur <= colonecran)
    {
        if (car < ' ')
        {
            if (car == TAB)
            {
                while (((colcurseur - coldeblig) & 7) != 0)
                    affcar (TRACETAB);

                putchar (TRACETAB);
            }
            else
            {
                putchar ('^');
                affcar (car | '@');
            }
        }
        else
            putchar (car);

        colcurseur++;
    }
    else if (colcurseur == colonecran + 1)
    {
        putseq ("A");
        putseq ("79C");
        putchar ('>');

        colcurseur = 1;
        lignecurseur++;
    }
}

hautpage ()
{
    if (lignecurseur > 1)
    {
        putseq ("H");

        lignecurseur = 1;
        colcurseur   = 1;
    }

    posdebligne ();
}




baspage ()
{
    if (lignecurseur < lignecran)
    {
        putseq ("24B");

        lignecurseur = lignecran;
    }

    posdebligne ();
}




posdebligne ()
{
    if (colcurseur > 1)
    {
        putchar (CR);

        colcurseur = 1;
    }
}

recherche ()
{
    intxx numlref;
    int   coldeb, colfin;
    int   colbuf;
    octet trouve;


    if (*commande != 0)
    {
        if (*commande == '/')
            sens = 1;
        else
            sens = -1;

        if (szcom > 1)
            memoexpr (commande + 1, optregul);
    }

    affmode ();
    restorposit ();

    if (resyncbuf == 1)
        synchrocol ();

    coldeb = 0;

    if (! debfichier ())
    {
        do
        {
            reculebuf ();
            coldeb ++;
        }
        while (carcourant () != EOL && ! debfichier ());

        if (carcourant () == EOL)
        {
            avancebuf ();
            coldeb--;
        }

        colfin = coldeb;
    }

    numlref = numlig;
    chargeligne ();

    do
    {
        trouve = rechexpr (ligne, szlig, optregul, &coldeb, &colfin, sens);

        if (trouve)
        {
            deplverslig (numlig, numlref);

            posdeblig ();

            for (colbuf = 0; colbuf < coldeb; colbuf++)
                avancebuf ();

            syncolbuf ();

            if (reaffmode)
                affmode ();

            if (nextcar () == 'n')
            {
                if (sens > 0)
                {
                    while (coldeb++ <= colfin)
                        avancebuf ();
                }
                else
                {
                    reculebuf ();

                    if (coldeb > 0)
                        colfin = coldeb - 1;
                    else
                        colfin = 0;
                }
            }
        }
        else
        {
            if (sens > 0)
            {
                coldeb = 0;

                avancebuf ();

                if (finfichier ())
                {
                    if (numlref > numlig)
                        numlref = numlig;

                    posdebuf ();
                    numlig = 1;
                }
                else
                    numlig ++;

                chargeligne ();
            }
            else    /* sens < 0 */
            {
                posfinligprec ();

                if (debfichier ())
                {
                    while (! finfichier ())
                    {
                        posfinlig ();
                        numlig ++;
                    }
                }

                numlig --;
                posdeblig ();

                chargeligne ();
                colfin = szlig - 1;
            }
        }
    }
    while (! trouve && numlig != numlref);

    if (! trouve)
        trouve = rechexpr (ligne, szlig, optregul, &coldeb, &colfin, sens);

    if (! trouve)
    {
        if (optregul)
            message ("Expression non trouve");
        else
            message ("Chaine non trouve");
    }
}



chargeligne ()
{
    szlig = 0;

    while (carcourant () != EOL && ! finfichier ())
    {
        if (szlig < szmaxlig)
            ligne [szlig++] = carcourant ();

        avancebuf ();
    }
}

rechlimite ()
{
    /* caractres dlimitant des expressions */
    static char listeparaph [7] = "(){}[]";

    char  carcur, carech;
    char  chaine [70];
    intxx deplhauteur, lignorig;
    int   niveau;
    octet arret;
    octet i;


    if (resyncbuf == 1)
        synchrocol ();

    carcur = carcourant ();

    for (i = 0; listeparaph [i] != carcur && listeparaph [i] != 0; i++);

    if (listeparaph [i] != 0)
    {
        sauveposbuf ();

        deplhauteur = 0;
        niveau = 1;
        lignorig = numlig;

        if (i & 1)
            carech = listeparaph [i - 1];
        else
            carech = listeparaph [i + 1];

        do
        {
            if (carech > carcur)
            {
                avancebuf ();
                arret = finfichier ();
            }
            else
            {
                reculebuf ();
                arret = debfichier ();
            }

            if (carcourant () == carech)
                niveau --;

            else if (carcourant () == carcur)
                niveau++;

            else if (carcourant () == EOL)
                deplhauteur ++;
        }
        while (niveau > 0 && ! arret);

        if (niveau == 0)
        {
            if (deplhauteur)
            {
                if (carech > carcur)
                    numlig = numlig + deplhauteur;
                else
                    numlig = numlig - deplhauteur;

                deplverslig (numlig, lignorig);
            }

            syncolbuf ();
        }
        else
        {
            restorposbuf ();

            if (carech > carcur)
                message ("Fin d'expression ou de paragraphe non trouv");
            else
                message ("Dbut d'expression ou de paragraphe non trouv");
        }
    }
    else
    {
        bip ();
        sprintf (chaine, "Le caractre '%c' n'a pas de symtrique", carcur);
        message (chaine);
    }
}

majauto (debloc, finbloc)
intxx debloc, finbloc;
{
    octet chainrpl [colonecran];
    octet debexpr, szrpl, optgen, car1, car2;
    int   coldeb, colfin, i;


    poscom = poscom + 2;
    debexpr = poscom;

    while (commande [poscom] != '/' && commande [poscom] != 0)
        if (commande [poscom++] == '\\')
            poscom ++;

    if (commande [poscom] == '/')
    {
        commande [poscom++] = 0;

        szrpl = 0;

        while (commande [poscom] != '/' && commande [poscom] != 0)
        {
            if (commande [poscom] == '\\')
            {
                if (commande [++poscom] == 'x')
                {
                    car1 = commande [++poscom];
                    car2 = commande [++poscom];

                    if (chiffre (car1))
                        car1 = car1 & 0x0F;
                    else
                        car1 = (car1 & 7) + 9;

                    if (chiffre (car2))
                        car2 = car2 & 0x0F;
                    else
                        car2 = (car2 & 7) + 9;

                    commande [poscom] = (car1 << 4) | (car2 & 0x0F);
                }
            }

            chainrpl [szrpl++] = commande [poscom++];
        }

        if (commande [poscom] == '/' && commande [poscom + 1] == 'g')
            optgen = 1;
        else
            optgen = 0;

        memoexpr (commande + debexpr, optregul);

        positlig (debloc - 1);

        maxinsert = insertmax ();

        sauveposbuf ();
        copdebuf ();

        while (numlig <= finbloc && (! finfichier ()))
        {
            chargeligne ();

            coldeb = 0;
            i = 0;

            if (rechexpr (ligne, szlig, optregul, &coldeb, &colfin, 1))
            {
                while (i < coldeb)
                    ajoutbuf2 (ligne [i++]);

                for (i = 0; i < szrpl; i++)
                    ajoutbuf2 (chainrpl [i]);

                i = colfin + 1;

                if (optgen)
                {
                    coldeb = colfin + 1;

                    while (rechexpr (ligne, szlig, optregul, &coldeb, &colfin, 1))
                    {
                        while (i < coldeb)
                            ajoutbuf2 (ligne [i++]);

                        for (i = 0; i < szrpl; i++)
                            ajoutbuf2 (chainrpl [i]);

                        coldeb = colfin + 1;
                        i = colfin + 1;
                    }
                }
            }

            while (i < szlig)
                ajoutbuf2 (ligne [i++]);

            if (! finfichier ())
            {
                ajoutbuf2 (carcourant ());
                avancebuf ();
            }

            numlig ++;
        }

        copfinbuf ();

        sauveposit ();
        baspage ();
        effligne ();
        restorposit ();

        restorposbuf ();
        numlig = debloc;
        affinpage ();
        testfplein ();
    }
    else
        errsynt ();
}

int trtescape ()
{
    if (optescape == OPTPOLICE && codepolice () != 0)
    {
        if (police < 0)
        {
            polcourante = polcourante & (police - 1);

            putseq ("0");

            if (polcourante & ITALIQUE)
            {
                printf (";7");

                if (polcourante & CARGRAS)
                    printf (";1;4");
            }
            else
            {
                if (polcourante & CARGRAS)
                    printf (";1");

                if (polcourante & SOULIGNE)
                    printf (";4");
            }

            putchar ('m');

            avancebuf ();
            return (2);
        }
        else if (police > 0)
        {
            polcourante = polcourante | police;

            if (polcourante & ITALIQUE)
            {
                putseq ("0;7");

                if (polcourante & CARGRAS)
                    printf (";1;4");

                putchar ('m');
            }
            else
            {
                if (polcourante & CARGRAS)
                    putseq ("1m");

                if (polcourante & SOULIGNE)
                    putseq ("4m");
            }
            avancebuf ();
            return (1);
        }
    }
    else if (optescape == OPTCOULEUR && codecouleur () >= 0)
    {
        putseq ("3");
        putchar ('0' | couleur);
        putchar ('m');
        avancebuf ();
        return (2);
    }

    affcar (ESC);
    avancebuf ();
    return (0);
}

int codecouleur ()
{
    char carcouleur;


    avancebuf ();

    if (carcourant () == 'c')
    {
        avancebuf ();
        carcouleur = carcourant ();

        for (couleur = 6; couleur >= 0 &&
                          carcouleur != listecouleur [couleur]; couleur--);
    }
    else
        couleur = -1;

    return (couleur);
}




int codepolice ()
{
    char  sens;
    octet carpol;


    avancebuf ();

    if (carcourant () == '-')
    {
        sens = -1;

        avancebuf ();
        carpol = carcourant ();
    }
    else
    {
        sens = 1;
        carpol = carcourant ();
    }

    switch (carpol)
    {
        case '_' : police = SOULIGNE * sens;
                   break;
        case 'g' : police = CARGRAS  * sens;
                   break;
        case '/' : police = ITALIQUE * sens;
                   break;
        default  : police = 0;
    }
    return (police);
}


poscurseur (ligne, colonne)
octet ligne, colonne;
{
    char sequence [7];

    sprintf (sequence, "%d;%dH", ligne, colonne);
    putseq (sequence);

    lignecurseur = ligne;
    colcurseur   = colonne;
}




effligne ()
{
    putseq ("K");
}




putseq (chaine)
char chaine [];
{
    putchar (ESC);
    putchar ('[');

    while (*chaine != 0)
        putchar (*(chaine++));

    fflush (stdout);
}

/*
      Fonctions de mise  jour des fichiers chargs
      par les programmes vi, gvi et mxvi
*/

affmode ()
{
    octet repositionner;


    if (lignecurseur != lignecran)
    {
        sauveposit ();
        baspage ();

        repositionner = 1;
    }
    else
    {
        putchar (CR);
        repositionner = 0;
    }

    printf ("                                                   ");
    effligne ();

    switch (mode)
    {
        case mode_commande     : printf ("             Mode commande");
                                 break;

        case mode_insertion    : printf ("            Mode insertion");
                                 break;

        case mode_remplacement : printf ("         Mode remplacement");
                                 break;

        case mode_substitution : printf ("         Mode substitution");
                                 break;

        default                : if (nbfois < 10)
                                 {
                                     putchar (' ');

                                     if (nbfois == 1)
                                         putchar (' ');
                                 }

                                 if (mode == mode_insere_x)
                                     printf ("   Insertion ");
                                 else
                                     printf ("Remplacement ");

                                 if (nbfois > 1)
                                     printf ("%d caractres", nbfois);
                                 else
                                     printf ("1 caractre");

                                 break;
    }

    if (repositionner)
        restorposit ();

    reaffmode = 0;
}

/* procedures de mise a jour du fichier */

insertion ()
{
    if (nbfois == 0)
        insertexte ();
    else
        inser_ncar ();

    mode = mode_commande;
    affmode ();

    if (reaffpage)
        reaffiche ();

    testfplein ();
}




insertexte ()
{
    if (resyncbuf == 1)
        synchrocol ();

    mode = mode_insertion;
    affmode ();

    maxinsert = insertmax ();

    if (maxinsert)
    {
        copdebuf ();

        leccar ();

        while (car != ESCAPE)
        {
            if (car & CARSPE)
            {
                if (HOME <= car && car <= SUPPRIME)
                    deplace ();
                else
                    bip ();
            }
            else
            {
                if ((caracc = testaccent ()) == 0)
                {
                    if ((carx = testx ()) == 0)
                    {
                        insercar (car);

                        if (car == TBKSP)
                            maxinsert ++;
                        else
                            maxinsert --;
                    }
                    else
                    {
                        putchar (BKSP);
                        putchar (carx);
                        majbuf2 (carx);
                    }
                }
                else
                {
                    putchar (BKSP);
                    putchar (caracc);
                    majbuf2 (caracc);
                }
            }

            if (maxinsert)
                leccar ();
            else
                car = ESCAPE;
        }

        copfinbuf ();
    }
}

inser_ncar ()
{
    if (resyncbuf == 1)
        synchrocol ();

    mode = mode_insere_x;
    affmode ();

    maxinsert = insertmax ();

    if (maxinsert)
    {
        leccar ();

        if ((car & CARSPE) == 0)
        {
            copdebuf ();

            if (nbfois == 1)
            {
                insercar (car);

                mode = mode_commande;
                affmode ();

                if ((caracc = testacc2 ()) != 0)
                {
                    putchar (BKSP);
                    putchar (caracc);
                    majbuf2 (caracc);
                    leccar ();
                }
                else if (testx2 () != 0)
                {
                    mode = mode_insere_x;
                    affmode ();

                    carx = codehexa ();

                    putchar (BKSP);
                    putchar (carx);
                    majbuf2 (carx);

                    mode = mode_commande;
                    affmode ();
                }
            }
            else
            {
                if (nbfois > maxinsert)
                    nbfois = maxinsert;

                while (nbfois-- > 0)
                    insercar (car);
            }

            copfinbuf ();
        }
        else
            bip ();
    }
}

remplace ()
{
    if (resyncbuf == 1)
        synchrocol ();

    mode = mode_remplacement;
    affmode ();

    copdebuf ();

    leccar ();

    while (car != ESCAPE && ! finfichier ())
    {
        if (car & CARSPE)
        {
            if (HOME <= car && car <= SUPPRIME)
                deplace ();
            else
                bip ();
        }
        else
        {
            if ((caracc = testaccent ()) == 0)
            {
                if ((carx = testx ()) == 0)
                    rplcar (car);
                else
                {
                    putchar (BKSP);
                    putchar (carx);
                    majbuf2 (carx);
                }
            }
            else
            {
                putchar (BKSP);
                putchar (caracc);
                majbuf2 (caracc);
            }
        }

        leccar ();
    }

    copfinbuf ();

    mode = mode_commande;
    affmode ();

    if (reaffpage)
        reaffiche ();

    testfinfic ();
}

rempl_ncar ()
{
    if (resyncbuf == 1)
        synchrocol ();

    mode = mode_remplace_x;
    affmode ();

    copdebuf ();

    if (! finfichier ())
    {
        leccar ();

        if ((car & CARSPE) == 0)
        {
            if (nbfois == 1)
            {
                rplcar (car);

                mode = mode_commande;
                affmode ();

                if ((caracc = testacc2 ()) != 0)
                {
                    putchar (BKSP);
                    putchar (caracc);
                    majbuf2 (caracc);
                    leccar ();
                }
                else if (testx2 () != 0)
                {
                    mode = mode_remplace_x;
                    affmode ();

                    carx = codehexa ();

                    putchar (BKSP);
                    putchar (carx);
                    majbuf2 (carx);

                    mode = mode_commande;
                    affmode ();
                }
            }
            else
                while (nbfois-- > 0 && ! finfichier ())
                    rplcar (car);
        }
        else
            bip ();

        copfinbuf ();
    }

    mode = mode_commande;
    affmode ();

    if (reaffpage)
        reaffiche ();

    testfinfic ();
}

detruit_avant (nbcar)
intxx nbcar;
{
    intxx cardetruits;


    if (resyncbuf == 1)
        synchrocol ();

    if (! finfichier ())
    {
        copdebuf ();

        cardetruits = 0;

        if (nbcar == 0)
        {
            do
            {
                detrcar_avant ();

                cardetruits++;

                while (nextcar () == 'u')
                {
                    if (cardetruits > 0)
                    {
                        restaure_avant ();
                        cardetruits--;
                    }
                    else
                    {
                        bip ();
                        car = carsuiv;
                        supcarid ();
                    }
                }
            }
            while (((carsuiv == 'x' && mode == mode_commande)
                  || carsuiv == SUPPRIME) && ! finfichier ());
        }
        else
        {
            lignechangee = 0;

            while (nbcar-- > 0 && ! finfichier ())
            {
                if (carcourant () == EOL)
                    lignechangee = 1;

                avancebuf ();
            }

            effligne ();

            if (lignechangee)
            {
                affinpage ();
            }
            else
            {
                sauveposit ();
                sauveposbuf ();
                affinlig ();
                restorposbuf ();
                restorposit ();
            }
        }

        copfinbuf ();
    }

    testfinfic ();
}

restaure_avant ()
{
    reculebuf ();
    car = carcourant ();

    if (car == EOL)
    {
        effligne ();

        if (lignecurseur < lignecran - 1)
            affinpage ();
    }
    else
    {
        if (car < ' ')
        {
            inscar (2);
            putchar ('^');
            putchar (car | '@');
            putseq ("2D");
        }
        else
        {
            inscar (1);
            putchar (car);
            putchar (BKSP);
        }
    }
}

detruit_arriere (nbcar)
intxx nbcar;
{
    intxx cardetruits;


    if (resyncbuf == 1)
        synchrocol ();

    if (! debfichier ())
    {
        sauveposbuf ();

        cardetruits = 0;

        if (nbcar == 0)
        {
            do
            {
                if (debfichier ())
                {
                    message ("Dbut de fichier atteint");

                    while (nextcar () == 'X')
                        bip ();

                    affmode ();
                }
                else
                {
                    reculebuf ();

                    if (carcourant () == EOL)
                    {
                        if (lignecurseur > 1)
                        {
                            putseq ("A");
                            lignecurseur --;
                        }

                        numlig --;
                        finligne ();
                        permutposbuf ();
                        affinpage ();
                        permutposbuf ();
                    }
                    else
                        detrcar_arriere (carcourant ());

                    cardetruits++;
                }

                while (nextcar () == 'u')
                {
                    if (cardetruits > 0)
                    {
                        if (carcourant () == EOL)
                        {
                            affeol ();

                            colcurseur = coldeblig;

                            sauveposit ();
                            permutposbuf ();
                            sauveposbuf ();
                            affinlig ();
                            restorposbuf ();
                            permutposbuf ();
                            restorposit ();

                            reaffmode = 1;
                        }
                        else
                        {
                            if (carcourant () < ' ')
                                inscar (2);
                            else
                                inscar (1);

                            affcar (carcourant ());
                        }

                        avancebuf ();

                        if (reaffmode)
                            affmode ();

                        cardetruits--;
                    }
                    else
                    {
                        bip ();
                        car = carsuiv;
                        supcarid ();
                    }
                }
            }
            while (carsuiv == 'X');

            copdebuf ();
            restorposbuf ();
            copfinbuf ();
        }
        else
        {
            lignechangee = 0;

            while (nbcar > 0 && ! debfichier ())
            {
                if (carcourant () == EOL)
                {
                    numlig --;

                    if (lignecurseur > 1)
                        lignecurseur --;
                }

                reculebuf ();
                nbcar --;
            }

            syncolbuf ();
            copdebuf ();
            restorposbuf ();
            copfinbuf ();
            affinpage ();
        }
    }
    else
        nbcar = 1;

    if (nbcar > 0)
    {
        message ("Dbut de fichier atteint");
        numlig = 1;
        attente_car ();
        affmode ();
    }
}

substitue (nbcar)
intxx nbcar;
{
    intxx nbrpl;


    if (resyncbuf == 1)
        synchrocol ();

    sauveposbuf ();
    sauveposit  ();

    mode = mode_substitution;
    affmode ();

    nbrpl = nbcar;

    while (--nbcar > 0)
    {
        if (carcourant () < ' ')
        {
            if (carcourant () == EOL)
            {
                lignecurseur ++;
                colcurseur = coldeblig;
            }
            else
                colcurseur = colcurseur + 2;
        }
        else
            colcurseur ++;

        avancebuf ();
    }

    if (lignecurseur < lignecran)
    {
        poscurseur (lignecurseur, colcurseur);
        putchar ('$');
    }

    restorposit  ();
    restorposbuf ();

    maxinsert = insertmax () + nbrpl;

    copdebuf ();

    leccar ();

    while (car != ESCAPE)
    {
        if (car & CARSPE)
        {
            if (nbrpl == 0 && HOME <= car && car <= SUPPRIME)
            {
                if (mode == mode_substitution)
                {
                    mode = mode_insertion;
                    reaffmode = 1;
                }

                deplace ();
            }
            else
                bip ();
        }
        else
        {
            if ((caracc = testaccent ()) == 0)
            {
                if ((carx = testx ()) == 0)
                {
                    if (nbrpl > 0)
                    {
                        rplcar (car);

                        if (car == TBKSP)
                            nbrpl ++;
                        else
                            nbrpl --;
                    }
                    else
                    {
                        insercar (car);

                        if (car == TBKSP)
                            maxinsert ++;
                        else
                            maxinsert --;
                    }
                }
                else
                {
                    putchar (BKSP);
                    putchar (carx);
                    majbuf2 (carx);
                }
            }
            else
            {
                putchar (BKSP);
                putchar (caracc);
                majbuf2 (caracc);
            }
        }

        if (maxinsert)
            leccar ();
        else
        {
            car = ESCAPE;
            bip ();
        }
    }

    if (nbrpl-- > 0)
    {
        lignechangee = 0;

        while (nbrpl-- > 0)
        {
            if (carcourant () == EOL)
                lignechangee = 1;

            avancebuf ();
        }

        avancebuf ();

        effligne ();

        if (lignechangee)
        {
            affinpage ();
        }
        else
        {
            sauveposit ();
            sauveposbuf ();
            affinlig ();
            restorposbuf ();
            restorposit ();
        }
    }

    mode = mode_commande;
    affmode ();

    copfinbuf ();

    if (reaffpage)
        reaffiche ();
}

Scom ()
{
    debligne ();

    copdebuf ();

    mode = mode_insertion;
    affmode ();

    effligne ();

    maxinsert = insertmax ();

    lignechangee = (nbfois > 1);

    do
    {
        if (! finfichier ())
        {
            do
            {
                avancebuf ();
                maxinsert ++;
            }
            while (! finfichier () && carcourant () != EOL);
        }
    }
    while (nbfois -- > 1);

    if (lignechangee)
        affinpage ();

    leccar ();

    while (car != ESCAPE)
    {
        if (car & CARSPE)
        {
            if (HOME <= car && car <= SUPPRIME)
                deplace ();
            else
                bip ();
        }
        else
        {
            if ((caracc = testaccent ()) == 0)
            {
                if ((carx = testx ()) == 0)
                {
                    insercar (car);

                    if (car == TBKSP)
                        maxinsert ++;
                    else
                        maxinsert --;
                }
                else
                {
                    putchar (BKSP);
                    putchar (carx);
                    majbuf2 (carx);
                }
            }
            else
            {
                putchar (BKSP);
                putchar (caracc);
                majbuf2 (caracc);
            }
        }

        if (maxinsert)
            leccar ();
        else
        {
            car = ESCAPE;
            bip ();
        }
    }

    mode = mode_commande;
    affmode ();

    if (reaffpage)
        reaffiche ();

    copfinbuf ();
}

joint ()
{
    finligne ();

    if (! finfichier ())
    {
        sauveposbuf ();

        copdebuf ();

        while (nbfois > 0 && ! finfichier ())
        {
            if (carcourant () == EOL)
            {
                ajoutbuf2 (' ');
                nbfois--;
            }
            else
                ajoutbuf2 (carcourant ());

            avancebuf ();
        }

        copfinbuf ();

        restorposbuf ();

        affinpage ();
    }

    testfinfic ();
}

tilde ()
{
    intxx carchanges;


    if (resyncbuf == 1)
        synchrocol ();

    if (! finfichier ())
    {
        copdebuf ();

        carchanges = 0;

        if (nbfois == 0)
        {
            do
            {
                car = carcourant ();

                if ('a' <= (car | 0x20) && (car | 0x20) <= 'z')
                    car = car ^ 0x20;

                rplcar (car);
                carchanges++;

                while (nextcar () == 'u')
                {
                    if (carchanges > 0)
                    {
                        supcarbuf2 ();

                        if (dercar2 () == EOL)
                        {
                            monte (1);
                            finligne ();
                        }
                        else
                        {
                            reculebuf ();

                            if (dercar2 () < ' ')
                            {
                                putseq ("2D");
                                colcurseur = colcurseur - 2;
                            }
                            else
                            {
                                putchar (BKSP);
                                putchar (carcourant ());
                                putchar (BKSP);

                                colcurseur --;
                            }
                        }

                        carchanges --;
                    }
                    else
                    {
                        bip ();
                        car = carsuiv;
                        supcarid ();
                    }
                }
            }
            while (carsuiv == '~' && ! finfichier ());
        }
        else
        {
            while (nbfois-- > 0 && ! finfichier ())
            {
                car = carcourant ();

                if ('a' <= (car | 0x20) && (car | 0x20) <= 'z')
                    car = car ^ 0x20;

                rplcar (car);
            }
        }

        copfinbuf ();
    }

    testfinfic ();
}

ajoutfic (position, fichier, lignedeb, lignefin)
intxx position, lignedeb, lignefin;
char  *fichier;
{
    intxx numl;


    adrfic = fopen (fichier, "rb");

    if (adrfic == 0)
        errcom ("fichier inexistant");
    else
    {
        numl = 1;

        carfic = getc (adrfic);

        while (carfic != EOF && numl < lignedeb)
        {
            if (carfic == EOL)
                numl ++;

            carfic = getc (adrfic);
        }

        if (carfic != EOF)
        {
            positlig (position);

            maxinsert = insertmax ();

            sauveposbuf ();
            copdebuf ();

            if (finfichier () && maxinsert > 0)
            {
                ajoutbuf2 (EOL);
                maxinsert --;
            }

            while (carfic != EOF && numl <= lignefin && maxinsert)
            {
                if (carfic == CR)
                {
                    carfic = getc (adrfic);

                    if (carfic != CR && carfic != EOL)
                    {
                        if (maxinsert > 0)
                        {
                            ajoutbuf2 (CR);
                            maxinsert --;
                        }
                    }
                }

                ajoutbuf2 (carfic);

                maxinsert --;

                if (carfic == EOL)
                    numl ++;

                carfic = getc (adrfic);
            }

            copfinbuf ();
            restorposbuf ();
            effligne ();
            affinpage ();
            testfplein ();
        }
        else
            errcom ("Il n'y a aucune donne  insrer");

        fclose (adrfic);
    }
}

copy (debloc, finbloc)
intxx debloc, finbloc;
{
    while (commande [poscom] == ' ')
        poscom++;

    if (chiffre (commande [poscom]) || commande [poscom] == '+'
        || commande [poscom] == '-' || commande [poscom] == '$')
    {
        positlig (valeur ());
        maxinsert = insertmax ();
        copdebuf ();
        sauveposbuf ();
        sauveposbuf ();
        sauveposit ();
        positbuf (debloc);

        while (debloc <= finbloc && maxinsert && ! finfichier ())
        {
            ajoutbuf2 (carcourant ());
            maxinsert --;

            if (carcourant () == EOL)
                debloc ++;

            avancebuf ();
        }

        restorposbuf ();
        copfinbuf ();
        restorposbuf ();
        restorposit ();
        affinpage ();
        affmode ();
        testfplein ();
    }
    else
        errcom ("Il faut prciser la ligne de destination");
}

move (debloc, finbloc)
intxx debloc, finbloc;
{
    intxx destination;


    while (commande [poscom] == ' ')
        poscom++;

    if (chiffre (commande [poscom]) || commande [poscom] == '+'
        || commande [poscom] == '-' || commande [poscom] == '$')
    {
        destination = valeur ();

        if (destination < debloc - 1)
        {
            positlig (destination);
            copdebuf ();
            sauveposbuf ();
            sauveposbuf ();
            sauveposit ();
            positbuf (debloc);
            copiebloc (finbloc - debloc + 1);
            restorposbuf ();
            copiebloc (debloc - destination - 1);
            numlig = debloc;
            positbuf (finbloc + 1);
            copfinbuf ();
            restorposbuf ();
            restorposit ();
            affinpage ();
            affmode ();
        }
        else if (destination > finbloc)
        {
            positlig (destination);
            sauveposit ();
            positbuf (debloc);
            sauveposbuf ();
            copdebuf ();
            positbuf (finbloc + 1);
            copiebloc (destination - finbloc);
            restorposbuf ();
            copiebloc (finbloc - debloc + 1);
            numlig = finbloc;
            positbuf (destination);
            copfinbuf ();
            restorposit ();
            saveposref ();
            reaffiche ();
            affmode ();
        }
        else if (destination == debloc - 1)
            errcom ("Le bloc est dj  la position demande");
        else
            errcom ("La destination ne doit pas tre dans le bloc  dplacer");
    }
    else
        errcom ("Il faut prciser la ligne de destination");
}

copiebloc (nblig)
intxx nblig;
{
    while (nblig > 0 && ! finfichier ())
    {
        ajoutbuf2 (carcourant ());

        if (carcourant () == EOL)
        {
            nblig --;
            numlig ++;
        }

        avancebuf ();
    }
}

insercar (caract)
int caract;
{
    octet carsupr;


    if (caract == TBKSP)
    {
        carsupr = dercar2 ();
        supcarbuf2 ();

        if (dercar2 () == EOL)
        {
            bip ();
            ajoutbuf2 (carsupr);
        }
        else
            detrcar_arriere (dercar2 ());
    }
    else if (caract == ENTER || caract == EOL)
    {
        affeol ();
        insereol ();
    }
    else
    {
        ajoutbuf2 (caract);

        if (colcurseur + 1 >= colonecran)
            majdecald ();

        if (caract < ' ')
            inscar (2);
        else
            inscar (1);

        affcar (caract);
    }
}

affeol ()
{
    effligne ();
    putchar (EOL);
    numlig ++;

    if (decald)
    {
        decald = 0;
        reaffpage = 1;
    }

    if (lignecurseur + 1 < lignecran)
    {
        lignecurseur ++;

        inserligne ();

        if (optnuml)
            affinuml ();
    }
    else
    {
        effligne ();
        putchar (EOL);
        putseq ("A");
    }

    putchar (CR);

    affdeblig ();
}

insereol ()
{
    int nblancs, ntabs, i;


    ajoutbuf2 (EOL);

    if (optindente)
    {
        posfinbuf2 ();

        reculebuf2 ();

        do
            reculebuf2 ();
        while (! debfich2 () && carcourant2 () != EOL);

        nblancs = 0;
        ntabs = 0;

        if (carcourant2 () == EOL)
            avancebuf2 ();

        while (carcourant2 () == ' ' || carcourant2 () == TAB)
        {
            if (carcourant2 () == TAB)
            {
                while (nblancs)
                {
                    ntabs ++;
                    affcar (TAB);

                    if (nblancs > 8)
                        nblancs = nblancs - 8;
                    else
                        nblancs = 0;
                }

                ntabs++;
                affcar (TAB);
            }
            else
                nblancs++;

            avancebuf2 ();
        }

        for (i = 0; i < nblancs; i++)
            affcar (' ');

        posfinbuf2 ();

        if (carcourant () == EOL)
        {
            affmode ();

            while (nextcar () == ENTER && maxinsert)
            {
                affmode ();

                numlig ++;

                if (lignecurseur + 1 < lignecran)
                {
                    putseq ("B");
                    lignecurseur ++;
                    inserligne ();
                }
                else
                {
                    putchar (EOL);
                    effligne ();
                    putchar (EOL);
                    putseq ("A");
                }

                if (optnuml)
                    affinuml ();

                ajoutbuf2 (EOL);
                maxinsert --;

                affmode ();
            }
        }
    }

    if (carcourant () != EOL)
    {
        sauveposit ();
        sauveposbuf ();
        affinlig ();
        restorposbuf ();
        restorposit ();

        affmode ();
    }

    if (optindente)
    {
        if (suivantlu == 0)
            nextcar ();

        if (carsuiv != ESCAPE || carcourant () != EOL)
        {
            while (ntabs-- && maxinsert)
            {
                ajoutbuf2 (TAB);
                maxinsert --;
            }

            while (nblancs-- && maxinsert)
            {
                ajoutbuf2 (' ');
                maxinsert --;
            }
        }
    }
}

rplcar (caract)
int caract;
{
    int   decalage;
    octet carsupr;


    if (caract == TBKSP)
    {
        carsupr = dercar2 ();
        supcarbuf2 ();
        reculebuf ();

        if (dercar2 () == EOL)
        {
            bip ();
            avancebuf ();
            ajoutbuf2 (carsupr);
        }
        else
        {
            if (dercar2 () < ' ')
            {
                decalage = -1;
                putseq ("2D");
            }
            else
            {
                decalage = 0;
                putseq ("D");
            }

            if (carcourant () == EOL)
            {
                colcurseur = wherex ();
                affinpage ();
            }
            else
            {
                if (carcourant () < ' ')
                    decalage ++;

                if (decalage == -1)
                    delcar (1);
                else if (decalage == 1)
                    inscar (1);

                affcar (carcourant ());

                if (carcourant () < ' ')
                    putseq ("2D");
                else
                    putseq ("D");

                colcurseur = wherex ();
            }
        }
    }
    else
    {
        if (caract == ENTER)
            caract = EOL;

        ajoutbuf2 (caract);

        if (caract == EOL)
        {
            numlig ++;

            if (decald)
            {
                decald = 0;
                reaffpage = 1;
            }

            if (carcourant () == EOL)
            {
                avancebuf ();
                putchar (EOL);

                if (lignecurseur + 1 < lignecran)
                {
                    lignecurseur ++;

                    affdeblig ();
                }
                else
                {
                    putchar (EOL);
                    putseq ("A");
                    effligne ();
                    affdeblig ();

                    if (carcourant () != EOL)
                    {
                        sauveposit ();
                        sauveposbuf ();
                        affinlig ();
                        restorposbuf ();
                        restorposit ();
                    }

                    reaffmode = 1;
                }
            }
            else
            {
                avancebuf ();
                effligne ();
                putchar (EOL);

                if (lignecurseur + 1 < lignecran)
                {
                    lignecurseur ++;

                    inserligne ();

                    if (optnuml)
                        affinuml ();
                }
                else
                {
                    effligne ();
                    putchar (EOL);
                    putseq ("A");
                }

                putchar (CR);

                affdeblig ();

                if (carcourant () != EOL)
                {
                    sauveposit ();
                    sauveposbuf ();
                    affinlig ();
                    restorposbuf ();
                    restorposit ();
                }

                reaffmode = 1;
            }
        }
        else
        {
            if (carcourant () == EOL)
            {
                affcar (caract);
                avancebuf ();
                affinpage ();
            }
            else
            {
                if (caract < ' ')
                    decalage = 1;
                else
                    decalage = 0;

                if (colcurseur + decalage >= colonecran)
                    majdecald ();

                if (carcourant () < ' ')
                    decalage --;

                if (decalage == -1)
                    delcar (1);
                else if (decalage == 1)
                    inscar (1);

                affcar (caract);

                avancebuf ();
            }
        }
    }
}

detrcar_avant ()
{
    if (carcourant () == EOL)
    {
        avancebuf ();
        affinpage ();
    }
    else
    {
        if (carcourant () < ' ')
            delcar (2);
        else
            delcar (1);

        avancebuf ();
    }
}




detrcar_arriere (caract)
octet caract;
{
    if (caract < ' ')
    {
        putseq ("2D");
        colcurseur = colcurseur - 2;
        delcar (2);
    }
    else
    {
        putchar (BKSP);
        colcurseur --;
        delcar (1);
    }
}

deplace ()
{
    copfinbuf ();

    if (reaffpage)
        reaffiche ();

    do
    {
        switch (car)
        {
            case AVANCE  : avance (1);
                           break;

            case RECULE  : recule (1);
                           break;

            case MONTE   : monte (1);
                           break;

            case DESCEND : descend (1);
                           break;

            case PAGEUP  : monte (lignecran + lignecurseur - 2);
                           break;

            case PAGEDOWN: descend (2 * lignecran - lignecurseur - 2);
                           break;

            case HOME    : debligne ();
                           break;

            case END     : finligne ();
                           break;

            case SUPPRIME: detruit_avant (0);
                           break;
        }

        leccar ();
    }
    while (HOME <= car && car <= SUPPRIME);

    synchrocol ();

    copdebuf ();

    carsuiv = car;
    suivantlu = 1;
}




testfinfic ()
{
    if (finfichier ())
        message ("Fin de fichier atteinte");
}




testfplein ()
{
    if (maxinsert == 0)
#ifdef vi
        message ("Taille maximale atteinte pour ce fichier. (Utiliser gvi).");
#else
        message ("Taille maximale atteinte pour ce fichier. (Utiliser mxvi).");
#endif
}

/* Sous programmes spcifiques  MS-DOS */

inscar (nbcar)
char nbcar;
{
    movetext (colcurseur, lignecurseur, colonecran - nbcar, lignecurseur,
                                        colcurseur + nbcar, lignecurseur);

    putchar (' ');
    putchar (BKSP);
}




delcar (nbcar)
char nbcar;
{
    movetext (colcurseur + nbcar, lignecurseur, colonecran, lignecurseur,
                                                colcurseur, lignecurseur);
}




majdecald ()
{
    octet savecol;


    savecol = colcurseur;

    movetext (coldeblig + stepdecald, lignecurseur, colonecran, lignecurseur,
                                                     coldeblig, lignecurseur);

    poscurseur (lignecurseur, coldeblig);
    putchar ('<');

    colcurseur = savecol - stepdecald;
    poscurseur (lignecurseur, savecol - stepdecald);
    effligne ();

    decald = decald + stepdecald;
    reaffpage = 1;
}




inserligne ()
{
    insline ();
}
