#include <stdio.h>
#include <dos.h>

static char *listemois [12] = {"Janvier", "Fvrier", "Mars", "Avril", "Mai",
                               "Juin", "Juillet", "Aout", "Septembre",
                               "Octobre", "Novembre", "Dcembre"};

static int jsemdeb [12];
static int nbjours [12];


main (narg, varg)
int  narg;
char *varg [];
{
    struct date datecur;


    if (--narg > 0)
    {
        do
        {
            varg ++;
            cal (atoi (*varg));

            if (--narg > 0)
                putchar ('\n');
        }
        while (narg > 0);
    }
    else
    {
        getdate (&datecur);
        cal (datecur.da_year);
    }
}


cal (an)
int an;
{
    int trim, sem;
    int i;


    if (an < 100)
    {
        if (an < 40)
            an = an + 2000;
        else
            an = an + 1900;
    }

    calc_semaines (an);

    putblancs (34);
    printf ("%4d\n\n", an);

    for (trim = 0; trim < 12; trim = trim +3)
    {
        putblancs (2);

        for (i = 0; i < 3; i++)
            affmois (trim + i);

        puts ("\n");

        for (i = 0; i < 3; i++)
            printf ("   Lu Ma Me Je Ve Sa Di");

        putchar ('\n');

        for (sem = 0; sem < 6; sem++)
        {
            for (i = 0; i < 3; i++)
                affsem (sem, trim + i);

            putchar ('\n');
        }
    }
}


calc_semaines (annee)
int annee;
{
    int mois;
    int
    long numjouran;
    long numjour1 [12];


    numjouran = annee + ((annee - 1) / 4) - (((annee + 99) / 100) * 3 / 4);
    numjour1 [0] = numjouran;
    numjour1 [1] = numjour1 [0] + 31;
    numjouran = annee + (annee / 4) - (((annee + 100) / 100) * 3 / 4) - 1;

    for (mois = 2; mois < 12; mois ++)
    {
        numjour1 [mois] = numjouran + (mois * 30) + ((mois - 1) * 10 / 17);
        nbjours [mois - 1] = numjour1 [mois] - numjour1 [mois - 1];
    }

    nbjours [0] = 31;
    nbjours [11] = 31;

    for (mois = 0; mois < 12; mois ++)
        jsemdeb [mois] = numjour1 [mois] % 7;
}


putblancs (nblancs)
int nblancs;
{
    while (nblancs-- > 0)
        putchar (' ');
}


affmois (mois)
int mois;
{
    int nblancs, avant;


    nblancs = 23 - strlen (listemois [mois]);
    avant = nblancs / 2;

    putblancs (avant);
    printf (listemois [mois]);
    putblancs (nblancs - avant);
}


affsem (sem, mois)
int sem, mois;
{
    int jourmois;
    int jsem;


    if (jsemdeb [mois] > 0)
        jourmois = (sem * 7) + 2 - jsemdeb [mois];
    else
        jourmois = (sem * 7) - 5;

    putblancs (2);

    for (jsem = 0; jsem < 7; jsem ++)
    {
        if ((1 <= jourmois) && (jourmois <= nbjours [mois]))
            printf ("%3d", jourmois);
        else
            putblancs (3);

        jourmois ++;
    }
}
