/* Programmes diffpred, diflpred etc...

   Les diffrents excutables s'obtiennnent
   en rebaptisant le fichier diffpred.exe
*/

#include <stdio.h>
#include <stdlib.h>


/* noms des fichiers utiliss */
static char nomcom  [9];
static char nomdiff [12];
static char *chemfich;
static char nombak  [13];
static char chembak [80];

/* programme principal */

main (narg, varg)
int narg;
char *varg [];
{
    char *varenv;
    char *carcur, *cardeb;
    char niveau;
    int i;


    /* rcupration du nom de la commande lance */
    carcur = *varg;
    cardeb = carcur;

    while (*carcur != 0)
    {
        if (*carcur == '\\')
            cardeb = ++carcur;
        else
            carcur ++;
    }

    for (i = 0; *cardeb != '.'; i++)
    {
        nomcom [i] = *cardeb | 0x20;
        cardeb ++;
    }

    nomcom [i] = 0;

    /* fabrication du nom du comparateur associ */
    strcpy (nomdiff, nomcom);
    nomdiff [strlen (nomcom) - 4] = 0;

    if (nomdiff [2] == 'f' && nomdiff [3] != 'f')
    {
        nomdiff [5] = nomdiff [4];
        nomdiff [4] = nomdiff [3];
        nomdiff [3] = nomdiff [2];
    }

    /* Test de la prsence de sauvegardes lors de l'appel de ..vi.. */
    varenv = getenv ("BAKDIR");

    if (varenv || getenv ("NBBAK"))
    {
        /* analyse des arguments de la commande */
        if (atoi (varg [1]) != 0 && narg > 2)
        {
            niveau = atoi (varg [1]) + '0';

            if (niveau > '9')
                niveau = niveau + 7;

            varg ++;
            narg --;
        }
        else
            niveau = '1';

        for (i = 1; *varg [i] == '-'; i++)
        {
            if (strcmp (varg [i], "-d") == 0)
            {
                fprintf (stderr, "Option -d incompatible avec %s\n", nomcom);
                psyntaxe ();
            }
        }

        /* controle du nombre de fichiers passs en paramtre */
        switch (narg - i)
        {
            case  0 : fputs ("Il manque le nom du fichier\n", stderr);
                      psyntaxe ();

            case  1 : break;

            default : fprintf (stderr,
                   "Il ne faut qu'un seul nom de fichier avec %s\n", nomcom);
                      psyntaxe ();
        }

        /* nom du fichier */
        chemfich = varg [i];

        /* rcupration du rpertoire de sauvegarde */
        if (varenv)
        {
            strcpy (chembak, varenv);

            carcur = chembak + strlen (chembak) - 1;

            if (*chembak && *carcur != '\\' && *carcur != '/')
            {
                carcur ++;

                *carcur = '/';
                *(carcur + 1) = 0;
            }
        }
        else
            *chembak = 0;

        /* rcupration du nom du fichier sans le chemin d'accs */
        carcur = chemfich;
        cardeb = carcur;

        while (*carcur != 0)
        {
            if (*carcur == '\\' || *carcur == '/')
                cardeb = ++carcur;
            else
                carcur ++;
        }

        strcpy (nombak, cardeb);

        /* fabrication de la version prcdente du nom du fichier */
        carcur = nombak + 1;

        while (*carcur != '.' && *carcur != 0)
            carcur ++;

        cardeb = carcur;

        for (i = 0; *carcur != 0; i++)
            carcur ++;

        switch (i)
        {
            case 0 : *(carcur ++) = '.';
                     break;

            case 4 : carcur --;
        }

        *carcur = niveau;
        * (carcur + 1) = 0;

        strcat (chembak, nombak);

        strcat (nomdiff, ".exe");

        if (access (chembak, 0) == 0)
        {
            varg [narg - 1] = chembak;
            varg [narg]     = chemfich;
            varg [narg + 1] = 0;

            execvp (nomdiff, varg);

            fprintf (stderr, "Commande %s inaccessible\n", nomdiff);
        }
        else if (niveau == '1')
            fprintf (stderr, "Le fichier %s n'a pas t sauvegard\n",
                                                                 chemfich);
        else
            fprintf (stderr, "Il n'y a pas de sauvegarde de niveau %d pour le fichier %s\n",
                                                     atoi (*varg), chemfich);
    }
    else
        fputs (
      "Il n'y a pas de sauvegardes faites lors des appels de vi et drivs\n",
               stderr);
}




psyntaxe ()
{
    fprintf (stderr,
    "Syntaxe : %s [<niveau de sauvegarde>] [-b] [-t] <nom de fichier>\n",
                                                                  nomcom);
    exit (-1);
}
