#include <stdio.h>
#include <dir.h>

static int  niveau_max = 0x7FFF;
static int  profondeur = 0;

static char debchemin;

static unsigned szbloc;


/* prototype de fonction */
unsigned long du (char chaine []);


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    char disque, szchemin;
    char *poschn;
    int place [4];
    struct ffblk fich;

    varg++;

    if ((narg > 1) && **varg == '-' && *(*varg + 1) == 's')
    {
        niveau_max = atoi (*varg + 2);

        narg--;
        varg++;
    }

    /* rpter */
    do
    {
        if (varg [0][1] == ':')
        {
            disque = **varg & 0x1f;
            debchemin = 2;
        }
        else
        {
            disque = 0;
            debchemin = 0;
        }

        /* rcuprer les caractristiques du disque */
        getdfree (disque, place);

        if (place [3] > 0)
        {
            poschn = *varg;

            do
            {
                if (*poschn == '\\')
                    *poschn = '/';
                else if (*poschn >= 'a' && *poschn <= 'z')
                    *poschn = *poschn - 0x20;

                poschn++;
            }
            while (*poschn != 0);

            szchemin = strlen (*varg);

            if ((szchemin > 0) && ((varg [0][szchemin - 1] == '/')
                                || (varg [0][szchemin - 1] == '.')))
                szchemin--;

            if (szchemin == debchemin)
            {
                if (place [0] == place [1])
                    printf ("      0 Koctets dans %s\n", *varg);
                else
                {
                    szbloc = place [2] * place [3];

                    if (**varg == 0)
                    {
                        varg--;
                        **varg = '.';
                        varg [0][1] = 0;
                    }

                    du (*varg);
                }
            }
            else
            {
                szbloc = place [2] * place [3];

                if (findfirst (*varg, &fich, 0x37) == 0)
                {
                    if (fich.ff_attrib & 0x10)
                        du (*varg);
                    else
                        fprintf (stderr, "%s est un fichier\n", *varg);
                }
                else if (findfirst (*varg, &fich, 0x8) == 0)
                    fprintf (stderr, "%s est un label\n", *varg);
                else
                    fprintf (stderr, "%s inexistant\n", *varg);
            }
        }

        varg++;
    }
    while (--narg > 1);
}


unsigned long du (chaine)
char chaine [];
{
    unsigned long nkoct, nbloc = 0, nblocf = 0;
    unsigned char szchemin;
    char dercar, szchaine, trouve;
    char chemin [256];
    struct ffblk fich;

    szchaine = strlen (chaine);

    if ((szchaine > 0) && (strcmp (chaine, ".") != 0))
    {
        dercar = chaine [szchaine - 1];

        if (dercar == '/')
            sprintf (chemin, "%s*.*", chaine);
        else
            sprintf (chemin, "%s/*.*", chaine);
    }
    else
        sprintf (chemin, "*.*");

    trouve = findfirst (chemin, &fich, 0xff);

    szchemin = strlen (chemin) - 3;

    if (strcmp (fich.ff_name, ".") == 0)
        trouve = findnext (&fich);

    if (strcmp (fich.ff_name, "..") == 0)
        trouve = findnext (&fich);

    while (trouve == 0)
    {
        if (fich.ff_attrib & 0x10)
        {
            sprintf (&chemin [szchemin], "%s", fich.ff_name);

            profondeur ++;
            nbloc = nbloc + du (chemin) + 1;
            profondeur --;
        }
        else if ((fich.ff_attrib & 0x0F) != 0x0F)
            nblocf = nblocf + ((fich.ff_fsize + szbloc - 1) / szbloc);

        trouve = findnext (&fich);
    }

    nbloc = nbloc + nblocf;

    if (profondeur <= niveau_max)
    {
        if (nblocf > 0)
        {
            nkoct = (nblocf * (szbloc / 512) + 1) / 2;
            printf ("%7lu Koctets de fichiers dans %s\n", nkoct, chaine);
        }

        if ((nbloc > nblocf) || (nbloc == 0))
        {
            nkoct = (nbloc * (szbloc / 512) + 1) / 2;
            printf ("%7lu Koctets dans %s\n", nkoct, chaine);
        }
    }

    return (nbloc);
}