#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <dir.h>

#define ESC  27

#define octet   unsigned char
#define int16   unsigned short

static int numdisk;
static octet buffer [32][16];

extern int errno;


main (narg, varg)
int narg;
char *varg [];
{
    char  car;
    char  ligne [80];
    int   numsect, dersect;


    /* slection du numdisk  lire */
    if (--narg > 0)
    {
        numdisk = atoi (varg [1]);

        if (numdisk > 0)
            numdisk = numdisk + 0x7F;
        else
            numdisk = -1 - numdisk;
    }
    else
    {
        puts ("\n1 : disquette");
        puts ("2 : disque dur\n");
        printf ("Votre choix ?  ");

        car = getche ();
        putchar ('\n');

        while (car != '1' && car != '2')
        {
            putchar (7);
            puts ("\n1 : disquette");
            puts ("2 : disque dur\n");
            printf ("Votre choix ?  ");

            car = getche ();
            putchar ('\n');
        }

        if (car == '1')
        {
            printf ("\nNumro de disquette ? ");
            numdisk = 0;
        }
        else
        {
            printf ("\nNumro de disque dur ? ");
            numdisk = 0x80;
        }

        numdisk = numdisk + getche () - '1';
        putchar ('\n');
    }

    if (narg > 1)
    {
        numsect = valeur (varg [2]);

        if (narg > 2)
            dersect = valeur (varg [3]);
        else
            dersect = numsect;

        while (numsect <= dersect)
            affsect (numsect ++, 0);
    }
    else
    {
        printf ("Numro de secteur ?   ESC pour sortir : ");

        car = getch ();

        while (car != ESC)
        {
            putchar (car);

            if (car == '\r')
            {
                putchar ('\n');
                numsect ++;
            }
            else
            {
                *ligne = car;

                gets (ligne + 1);
                puts (ligne);

                numsect = valeur (ligne);
            }

            affsect (numsect, 1);

            printf ("Numro de secteur ?   ESC pour sortir : ");
            car = getch ();
        }

        putchar ('\n');
    }
}



int valeur (chaine)
char *chaine;
{
    int   retour;
    octet vcar;


    /* initialisation */
    retour = 0;

    while (*chaine != 0)
    {
        vcar = *chaine & 0x0f;

        if (*chaine > '9')
            vcar = vcar + 9;

        retour = (retour << 4) | vcar;

        chaine ++;
    }

    return (retour);
}



affsect (numsect, arret)
int numsect, arret;
{
    int i, j;
    octet vcar;

    if (biosdisk (2, numdisk, 0, 0, numsect, 1, buffer) == 0)
    {
        printf ("\nSecteur : %5u, &%04X\n", numsect, numsect);
        puts ("     ---------------------------------------------------");
        puts ("     |  0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F |");
        puts ("--------------------------------------------------------");

        for (i = 0; i < 32; i++)
        {
            printf ("| %2X |", i);

            for (j = 0; j < 16; j++)
            {
                vcar = buffer [i][j];

                if (vcar < 16)
                    printf (" 0%X", vcar);
                else
                    printf (" %X", vcar);
            }

            printf (" |   ");

            for (j = 0; j < 16; j++)
            {
                vcar = buffer [i][j];

                if (vcar > 0x1b)
                    putchar (vcar);
                else
                    putchar ('.');
            }

            if (i == 15 && arret)
                getch ();

            putchar ('\n');
        }

        puts ("--------------------------------------------------------");
    }
    else
    {
        errno = errno >> 8;

        if (errno & 1)
            puts ("Instruction incorrecte");

        if (errno & 2)
        {
            printf ("Adresse incorrecte ");
            puts ("(numdisk inexistant)");
        }

        if (errno & 4)
            puts ("Secteur non trouv");

        if (errno & 8)
            puts ("Erreur DMA");

        if (errno & 0x10)
            puts ("Erreur CRC  (secteur dfectueux)");

        if (errno & 0x20)
            puts ("Erreur controleur numdisk");

        if (errno & 0x40)
            puts ("Recherche infructueuse");

        if (errno & 0x80)
            puts ("Le numdisk ne rpond pas");

        /* Certaines erreurs sont fatales */
        if (errno & 0x82)
            exit ();
    }
}
