#include <stdio.h>
#include <dir.h>

main (narg, varg)
int narg;
char *varg [];
{
    struct ffblk fich;

    /* positionnement sur le premier argument */
    *varg++;

    /* controle de la syntaxe */
    if (narg < 2)
        fprintf (stderr, "Syntaxe : rmd <liste de rpertoires>\n");
    else
    {
        /* boucle de travail */
        while (--narg > 0)
        {
            /* test d'existence du rpertoire */
            if (findfirst (*varg, &fich, 0xff) == 0)
            {
                /* destruction du rpertoire */
                if (rmdir (*varg) == -1)
                {
                    /* traitement d'erreur */
                    if (fich.ff_attrib & 0x10)
                        fprintf (stderr, "%s non vide ou accs refus\n",
                                                                *varg);
                    else
                        fprintf (stderr, "%s est un fichier\n", *varg);
                }
            }
            else
                fprintf (stderr, "Rpertoire %s inexistant\n", *varg);

            /* passage  l'argument suivant */
            *varg++;
        }
    }
}