#include <process.h>
#include <stdio.h>


static char sauvroot [13] = "sauvroot.exe";
static char sauveg   [11] = "sauveg.exe";


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    char dest [3];    /* disquette de destination */


    /* test des arguments */
    if (narg != 1 && (narg != 2 || varg [1][1] != ':' || varg [1][2] != 0))
        fputs ("Syntaxe : sauvgen [<nom de disquette>]\n", stderr);
    else
    {
        /* prendre en compte le nom de la disquette de destination */
        if (narg == 2)
            *dest = *varg [1] & 0x5f;
        else
            *dest = 'A';   /* disquette par dfaut */

        /* complter le nom de la disquette de destination */
        dest [1] = ':';
        dest [2] = 0;

        if (searchpath (sauvroot) != 0)
        {
            /* crer la disquette bootable */
            if (spawnlp (P_WAIT, sauvroot, sauvroot, dest, 0) == 1)
            {
                /* sauvegarder l'arborescence */
                execlp (sauveg, sauveg, "-sd", "/", dest, 0);

                /* l'instruction qui suit n'est atteinte que si
                   la commande sauveg n'a pas p tre lance */
                fputs ("Commande sauveg non trouve\n", stderr);
            }
        }
        else
            fputs ("Commande sauvroot non trouve\n", stderr);
    }
}
