#include <stdio.h>
#include <stdlib.h>
#include <io.h>


/* noms des fichiers utiliss */
static char *chemfich;
static char *nomfich;
static char nombak  [13];
static char chembak [80];
static char chembak2 [80];
static char *chemhier = chembak;  /* on rutilisera le mme tableau */

/* programme principal */

main (narg, varg)
int narg;
char *varg [];
{
    char *varenv;
    char *carcur, *carchn, *carchn2;
    int posdercar;
    int nbbak;
    int descfic;
    struct ftime datmaj;
    int i;


    /* controle du nombre de fichiers passs en paramtre */
    if (narg == 2)
    {
        /* rcupration du nom du fichier sans le chemin d'accs */
        chemfich = varg [1];
        carcur   = chemfich;

        /* termin si fichier inexistant */
        if (access (chemfich, 0) != 0)
        {
            fprintf (stderr, "Fichier %s inexistant\n", chemfich);
            exit (-1);
        }

        nomfich = carcur;

        while (*carcur != 0)
        {
            if (*carcur == '\\' || *carcur == '/')
                nomfich = ++carcur;
            else
                carcur ++;
        }

        varenv = getenv ("NBBAK");

        nbbak = 0;

        while ('0' <= *varenv && *varenv <= '9')
        {
            nbbak = (nbbak * 10) + *varenv - '0';
            varenv ++;
        }

        /* Test de la prsence de sauvegardes lors de l'appel de ..vi.. */
        varenv = getenv ("BAKDIR");

        if (varenv || (nbbak > 0))
        {
            if (nbbak < 1)
                nbbak = 1;

            else if (nbbak > 35)
                nbbak = 35;

            /* rcupration du rpertoire de sauvegarde */
            getchemin (chembak, varenv);

            /* fabrication de la version prcdente du nom du fichier */
            strcpy (nombak, nomfich);
            carcur = nombak + 1;

            while (*carcur != '.' && *carcur != 0)
                carcur ++;

            for (i = 0; *carcur != 0; i++)
                carcur ++;

            switch (i)
            {
                case 0 : *(carcur ++) = '.';
                         break;

                case 4 : carcur --;
            }

            *carcur = '1';
            *(carcur + 1) = 0;

            strcat (chembak, nombak);
            posdercar = strlen (chembak) - 1;
            carchn  = chembak + posdercar;

            strcpy (chembak2, chembak);
            carchn2 = chembak2 + posdercar;

            if (nbbak < 10)
                *carchn = '0' + nbbak;
            else
                *carchn = '@' + nbbak - 9;

            *carchn2 = '0';

            unlink (chembak2);

            if (rename (chembak, chembak2) >= 0)
            {
                do
                {
                    if (*carchn == '9')
                        *carchn = 'A';
                    else
                        *carchn = *carchn + 1;
                }
                while (unlink (chembak) >= 0);
            }

            sauver (chembak2);

            *carchn = 1;

            while (access (chembak2, 0) >= 0)
            {
                if (*carchn2 == '9')
                    *carchn2 = 'A';
                else
                    *carchn2 = *carchn2 + 1;
            }

            while (*carchn2 > '0')
            {
                *carchn = *carchn2;

                if (*carchn2 == 'A')
                    *carchn2 = '9';
                else
                    *carchn2 = *carchn2 - 1;

                rename (chembak2, chembak);
            }
        }

        if (getchemin (chemhier, getenv ("HIERDIR")))
        {
            strcat (chemhier, nomfich);

            if (access (chemhier, 0) != 0)
            {
                sauver (chemhier);

                descfic = open (chemfich, 0x8001);

                if (descfic > 0)
                {
                    getftime (descfic, &datmaj);
                    close (descfic);
                }

                descfic = open (chemhier, 0x8001);

                if (descfic > 0)
                {
                    setftime (descfic, &datmaj);
                    close (descfic);
                }
            }
        }
    }
    else
        fputs ("Syntaxe : savef <nom de fichier>\n", stderr);
}

/* rcupration du rpertoire de sauvegarde */
getchemin (destination, origine)
char *destination, *origine;
{
    char *carcur;


    if (origine)
    {
        strcpy (destination, origine);

        carcur = destination + strlen (destination) - 1;

        if (*destination && *carcur != '\\' && *carcur != '/')
        {
            mkdir (destination);   /* si ncessaire */

            carcur ++;

            *carcur = '/';
            *(carcur + 1) = 0;
        }
    }
    else
        *destination = 0;

}




sauver (destination)
char *destination;
{
    FILE *ficin, *ficout;
    int car;


    ficin  = fopen (chemfich, "rb");
    ficout = fopen (destination, "wb");

    if (ficout)
    {
        car = getc (ficin);

        while (car != EOF)
        {
            putc (car, ficout);

            car = getc (ficin);
        }

        fclose (ficin);

        if (fclose (ficout) == EOF)
        {
            unlink (destination);
            
            fprintf (stderr, "Manque d'espace disque pour sauver %s\n", chemfich);
            exit (-1);
        }
    }
}