#include <stdio.h>
#include <dos.h>
#include <io.h>

char *posarg;    /* caractre courant du premier argument (date) */
char errval = 0; /* indique si la valeur de la date est correcte */


main (narg, varg)
int narg;
char *varg [];
{
    struct ftime datmaj; /* date et heure de mise  jour des fichiers */
    struct date jourmaj; /* date de mise  jour du fichier */
    struct time heurmaj; /* heure de mise  jour du fichier */
    int descfic;         /* descripteur pour mise  jour de la date */

    /* se positionner sur le premier argument */
    *varg++;
    posarg = *varg;

    /* rcuprer la date (si elle existe) */
    getval (&jourmaj.da_day, 31);

    if (errval == 0)
        getval (&jourmaj.da_mon, 12);

    if (errval == 0)
    {
        getval (&jourmaj.da_year, 99);

        /* on tient compte du fait que jourmaj.da_year = variable entire */
        jourmaj.da_year &= 0xff;
    }

    if (errval == 0)
        getval (&heurmaj.ti_hour, 23);

    if (errval == 0)
        getval (&heurmaj.ti_min, 59);

    if (errval == 0)
    {
        /* la dfinition des secondes est facultative */
        getval (&heurmaj.ti_sec, 59);

        if (errval != 0)
            heurmaj.ti_sec = 0;

        /* se positionner sur le premier nom de fichier */
        varg++;
        narg--;
    }
    /* sinon, on rcupre la date et l'heure courante */
    else
    {
        getdate (&jourmaj);
        gettime (&heurmaj);

        /* troncation a 2 chiffres de l'anne */
        jourmaj.da_year -= 1900;
    }

    /* prise en compte de la date et de l'heure */
    datmaj.ft_day = jourmaj.da_day;
    datmaj.ft_month = jourmaj.da_mon;

    if (jourmaj.da_year < 80)
        datmaj.ft_year = jourmaj.da_year + 20;
    else
        datmaj.ft_year = jourmaj.da_year - 80;

    datmaj.ft_hour = heurmaj.ti_hour;
    datmaj.ft_min  = heurmaj.ti_min;
    datmaj.ft_tsec = heurmaj.ti_sec / 2;

    /* tantqu'il y a des fichiers ou des rpertoires  traiter */
    while (--narg > 0)
    {
        /* crr le fichier si ncessaire */
        fclose (fopen (*varg, "a"));

        /* mettre  jour la date du fichier */
        descfic = open (*varg, 0x8001);

        if (descfic > 0)
        {
            setftime (descfic, &datmaj);
            close (descfic);
        }
        else
            fprintf (stderr, "Le fichier %s n'a p tre cr\n", *varg);

        /* passer  l'argument suivant */
        *varg++;
    }
}


getval (var, max)
char *var;
char max;
{
    if (*posarg < '0' || *posarg > '9')
        errval = 1;
    else
    {
        *var = (*posarg++ - '0') * 10;

        if (*posarg < '0' || *posarg > '9')
            errval = 1;
        else
        {
            *var = *var + *posarg++ - '0';

            if (*var > max)
                errval = 1;
        }
    }
}