#include <stdio.h>

#define szmaxlig   1024

#define memorise      1
#define compare       2


main (narg, varg)
int narg;
char *varg [];
{
    char ligne [szmaxlig];  /* dernire ligne mmorise */
    int  szlig, szligprec;  /* sa taille et celle de la ligne prcdente */
    int  etat;              /* indique si diffrence entre 2 lignes */
    int  car;               /* caractre  comparer ou  afficher */
    int  i;                 /* compteur */


    /* initialisation ligne prcdente avec valeur impossible  trouver
       dans la pratique : la premire ligne du fichier sera affiche */
    szligprec = 1;
    ligne [0] = '\n';

    /* tant qu'il y a des fichiers  lire */
    do
    {
        *varg++;
        narg--;

        /* prise en compte des noms de fichiers de la ligne de commande */
        if (narg > 0)
        {
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        /* lecture du premier caractre */
        car = getchar ();

        /* tant que non fin de fichier */
        while (car != EOF)
        {
            /* on est en dbut de ligne */
            szlig = 0;
            etat  = compare;

            /* tant qu'on n'est pas en fin de ligne */
            while (car != '\n' && car != EOF)
            {
                /* et qu'on peut mmoriser des caractres */
                if (szlig < szmaxlig)
                {
                    /* si jusqu' prsent lignes identiques */
                    if (etat == compare)
                    {
                        /* comparer le caractre suivant */
                        if (ligne [szlig] != car || szlig >= szligprec)
                        {
                            /* on a trouv une diffrence */
                            etat = memorise;

                            /* afficher le dbut de la ligne */
                            for (i = 0; i < szlig; i++)
                                putchar (ligne [i]);
                        }
                    }

                    /* mmoriser le dernier caractre lu */
                    ligne [szlig++] = car;
                }

                /* si diffrence trouve dans la ligne, continuer l'affichage */
                if (etat == memorise)
                    putchar (car);

                /* lire le caractre suivant */
                car = getchar ();
            }

            /* si la nouvelle ligne est un morceau de la prcdente */
            if (etat == compare && szlig < szligprec)
            {
                /* l'afficher */
                for (i = 0; i < szlig; i++)
                    putchar (ligne [i]);

                putchar ('\n');
            }
            /* sinon terminer l'affichage de la ligne en cas de diffrence */
            else if (etat == memorise)
                putchar ('\n');

            /* la dernire ligne lue devient l'avant dernire */
            szligprec = szlig;

            /* lire le premier caractre de la ligne suivante */
            car = getchar ();
        }
    }
    while (narg > 1);
}
