#include <stdio.h>
#include <stdlib.h>

#define maxpath  255
#define nbsuff     5


static char path [maxpath];
static char *suffixes [nbsuff] = { "EXE", "COM", "SH", "RSH", "BAT" };

main (narg, varg)
int narg;
char *varg [];
{
    if (--narg > 0)
    {
        getpath ();

        do
        {
            varg++;

            getchemin (*varg);
        }
        while (--narg > 0);
    }
    else
        fprintf (stderr, "Syntaxe : utype <nom ou liste de fichier(s)>\n");
}


getpath ()
{
    char *carpath;
    char *shell;


    shell = getenv ("COMSPEC");

    if (strcmp (shell + strlen (shell) - 11, "COMMAND.COM") == 0)
    {
        *path = '.';
        *(path + 1) = 0;
        carpath = path + 2;
    }
    else
        carpath = path;


    strcpy (carpath, getenv ("PATH"));

    do
    {
        if (*carpath == ';')
            *carpath = 0;

        else if (*carpath == '\\')
            *carpath = '/';

        carpath ++;
    }
    while (*carpath != 0);

    *(carpath + 1) = 0;
}



getchemin (chaine)
char *chaine;
{
    char chemin [maxpath];
    char *carchem;
    char *dirpath;
    int suffixe;
    int trouve;
    int i;


    carchem = chaine;
    suffixe = 0;

    while (*carchem != 0 && suffixe == 0)
    {
        if (*carchem == '.')
            suffixe = 1;

        else if (*carchem >= 'a')
            *carchem = *carchem - 0x20;

        carchem ++;
    }

    dirpath = path;
    trouve = 0;

    do
    {
        strcpy (chemin, dirpath);


        carchem = chemin + strlen (chemin) - 1;

        if (*carchem != '/')
            *(++ carchem) = '/';

        strcpy (++carchem, chaine);

        if (suffixe)
            trouve = (access (chemin, 0) == 0);
        else
        {
            carchem = chemin + strlen (chemin);
            *(carchem ++) = '.';

            for (i = 0; i < nbsuff && trouve == 0; i++)
            {
                strcpy (carchem, suffixes [i]);

                trouve = (access (chemin, 0) == 0);
            }
        }

        do
            dirpath ++;
        while (*dirpath != 0);

        dirpath ++;
    }
    while (*dirpath != 0 && trouve == 0);

    if (trouve == 0)
        fprintf (stderr, "Commande %s non trouve\n", chaine);
    else
        puts (chemin);
}