/* Programme vi

*/

#ifndef globales
#include "constvi.h"
#include "globvi.c"
#endif


/* prototypes */
intxx valeur ();
intxx nbcarlig (intxx);
intxx nbcarmot (intxx, octet);
intxx nbcarbloc (intxx, octet);
monte (intxx);
descend (intxx);
ajoutfic (intxx, char *, intxx, intxx);


/* programme principal */

main (narg, varg)
int narg;
char *varg [];
{
    int  disque;
    char curdir [szchemin];


    /* fabrication du nom du fichier d'aide en ligne */
    strcpy (chemfich, *varg);

#ifdef gvi
    strcpy (chemfich + strlen (chemfich) - 7, "VI.HLP");
#else
    strcpy (chemfich + strlen (chemfich) - 3, "HLP");
#endif

    ficaide = fopen (chemfich, "rb");
    nomedit = *varg;

    varg++;
    narg--;

    while (**varg == '-')
    {
        trtarg (*varg);
        varg++;
        narg--;
    }

    if (narg == 0)
    {
        fputs ("Il faut prciser un nom de fichier\n", stderr);
        exit (-1);
    }

    att_alarme = atol (getenv ("alarme")) * (60 * TIC_SEC);

    cremem ();

    disque = getdisk ();
    getcwd (curdir, szchemin);

    while (narg > 0)
    {
        trtfichier (*varg);
        varg++;
        narg--;

        setdisk (disque);
        chdir (curdir);

        if (narg > 0)
        {
            putchar (CR);
            effligne ();
            printf (
     "Fichier suivant : %s    Appuyer sur un touche  ^C pour sortir", *varg);

            leccar ();

            putchar (EOL);

            if (car == '')
                exit (0);
        }
    }

    putchar (EOL);
}




trtarg (arg)
char *arg;
{
    arg ++;

    do
    {
        switch (*arg)
        {
            case 'a' : optaccent = 0;
                       break;

            case 'c' :
            case 'p' : optescape = *arg;
                       break;

            case 'i' : optindente = 0;
                       break;

            case 'n' : optnuml = 1;
                       break;

            case 'r' : optrecup = 1;
                       break;

            case 's' : optsave = 0;
                       break;

            default  : psyntaxe ();
        }

        arg ++;
    }
    while (*arg != 0);
}




psyntaxe ()
{
    nomedit = nomedit + strlen (nomedit) - 5;
    nomedit [1] = 0;

    while (*nomedit != '\\')
    {
        *nomedit = *nomedit | ' ';
        nomedit --;
    }

    nomedit ++;

    fprintf (stderr,
            "Syntaxe : %s [-a] [-i] [-n] [-(p|c)] [-s] [-r] <nom ou liste de fichier(s)>\n",
                                                                nomedit);
    exit (-1);
}

trtfichier (chaine)
char *chaine;
{
    int i, j;
    int newdisque;
    int debnomfic;
    int erreur = 0;


    if (chaine [1] == ':')
    {
        newdisque = (*chaine & 0x1F) - 1;
        setdisk (newdisque);

        if (getdisk () != newdisque)
            erreur = 1;

        chaine = chaine + 2;
    }

    if (erreur == 0)
    {
        debnomfic = 0;

        for (i = 0; chaine [i] != 0; i++)
            if (chaine [i] == '/' || chaine [i] == '\\')
                debnomfic = i + 1;

        if (debnomfic != 0)
        {
            chaine [debnomfic - 1] = 0;

            if (debnomfic > 1)
                erreur = chdir (chaine);
            else
                chdir ("/");
        }

        getcwd (chemfich, szchemin);

        if (erreur == 0)
        {
            if (chemfich [3] != 0)
                strcat (chemfich, "/");

            nomfich = chaine + debnomfic;

            for (i = 0; nomfich [i] != '.' && nomfich [i] != 0; i++)
                prefixe [i] = nomfich [i];

            prefixe [i] = 0;

            if (nomfich [i] == '.')
                i++;

            for (j = 0; j < szsuffixe; j++)
            {
                suffixe [j] = nomfich [i];

                if (nomfich [i] != 0)
                    i++;
            }

#ifndef mxvi
            strcpy (ficsave, chemfich);
            strcat (ficsave, prefixe);
            strcpy (fictmp,  ficsave);
            strcat (ficsave, ".sav");
            strcat (fictmp,  ".nsv");
            strcat (chemfich, nomfich);

            if (strcmp (chemfich, ficsave) == 0)
                ficsave [strlen (ficsave) - 1] = '2';

            else if (strcmp (chemfich, fictmp) == 0)
                fictmp [strlen (fictmp) - 1] = '2';
#else
            strcpy (fictrav, chemfich);
            strcat (fictrav, prefixe);
            strcpy (ficsuf,  fictrav);
            strcat (fictrav, ".trv");
            strcat (ficsuf,  ".suf");
            strcat (chemfich, nomfich);

            if (strcmp (chemfich, fictrav) == 0)
                fictrav [strlen (fictrav) - 1] = '2';

            else if (strcmp (chemfich, ficsuf) == 0)
                ficsuf [strlen (ficsuf) - 1] = '2';
#endif

            switch (testsavef ())
            {
/* recentrage a gauche */
case NON_SAUVE   : if (optrecup == 0)
                   {
                       if (charge ())
                           edition ();
                   }
                   else
                   {
                  printf ("Aucune sauvegarde de %s n'a t faite\n", nomfich);
                       puts ("lors d'un arrt brutal du calculateur");
                   }

                   break;

case SAUVE       : if (optrecup)
                   {
                       if (recharge ())
                           edition ();
                   }
                   else
                   {
                       printf ("Le fichier %s a t sauv", nomfich);
                       puts (" lors d'un arrt brutal du calculateur");
 puts ("Cette sauvegarde est plus rcente que le fichier d'origine ");
 puts   ("Voulez vous :\n");
 printf ("  1 : charger le fichier d'origine %s\n", nomfich);
 printf ("  2 : charger la sauvegarde de %s\n", nomfich);
                       printf ("\nVotre choix ?  ");
                   }

                   do
                       leccar ();
                   while (car != '1' && car != '2');

                   if (car == '1')
                   {
                       fclose (adrfic);

                       if (charge ())
                           edition ();
                   }
                   else
                   {
                       if (recharge ())
                           edition ();
                   }

                   break;

case AUTRE_SAUVE : if (*sufsauve)
                   {
                       strcat (prefixe, ".");
                       strcat (prefixe, sufsauve);
                   }

                   printf ("C'est le fichier %s qui a t sauv\n", prefixe);
                   puts ("lors d'un arrt brutal du calculateur");
printf ("Le chargement du fichier %s dtruira cette sauvegarde\n", nomfich);
                   puts   ("Voulez vous :\n");
                   printf ("  1 : charger le fichier %s\n", nomfich);
                   printf ("  2 : charger la sauvegarde de %s\n", prefixe);

                   printf ("\nVotre choix ?  ");

                   do
                       leccar ();
                   while (car != '1' && car != '2');

                   if (car == '1')
                   {
                       fclose (adrfic);

                       if (charge ())
                           edition ();
                   }
                   else
                   {
                       strcpy (chemfich + strlen (chemfich)
                                        - strlen (nomfich), prefixe);
                       nomfich = prefixe;

                       if (recharge ())
                           edition ();
                   }

                   break;
/* fin du recentrage */
            }
        }
        else
            fprintf (stderr, "Rpertoire %s inexistant\n", chaine);
    }
    else
        fprintf (stderr, "%c: n'est pas un disque accessible\n",
                                                            newdisque + 'A');
}

/* Procedures de chargement et de sauvegarde */

int testsavef ()
{
    int i;


#ifndef mxvi
    rename (fictmp, ficsave);

    adrfic = fopen (ficsave, "rb");

    if (adrfic == 0)
        return (NON_SAUVE);
#else
    if (access (fictrav, 6) < 0)
        return (NON_SAUVE);

    adrfic = fopen (ficsuf, "r+b");

    if (adrfic == 0)
    {
        memcpy (sufsauve, "???", szsuffixe);
        return (AUTRE_SAUVE);
    }
#endif

    for (i = 0; i < szsuffixe; i++)
        sufsauve [i] = getc (adrfic);

    if (memcmp (suffixe, sufsauve, szsuffixe))
        return (AUTRE_SAUVE);
    else
        return (SAUVE);
}




int charge ()
{
    initmem ();

#ifdef mxvi
    creeftrav ();
#endif

    typefichier = 0;

    adrfic = fopen (chemfich, "rb");

    if (adrfic != 0)
    {
        carfic = getc (adrfic);

        while (carfic != EOF && typefichier == 0)
        {
            if (carfic == EOL)
                typefichier = UNIX;

            else if (carfic == CR)
            {
                carfic = getc (adrfic);

                if (carfic == CR || carfic == EOL)
                    typefichier = MSDOS;
                else
                {
                    typefichier = UNIX;
                    ajoutbuf (CR);
                }
            }
            else
            {
                ajoutbuf (carfic);

                carfic = getc (adrfic);
            }
        }
    }
    else
        typefichier = UNIX;

    misajour = 0;
    savenuml = 0;

    if (fincharge ())
    {
        carfic = 0;

        if (adrfic != 0 && optsave == 1)
            sauvbak ();
        else
            putchar (CR);

        return (1);
    }
    else
        return (0);
}




int recharge ()
{
    initmem ();

    /* le fichier de sauvegarde a t ouvert dans testsauvef
       et le nom du suffixe a t lu */

#ifndef mxvi
    typefichier = getc (adrfic);
    savenuml = getw (adrfic);

    carfic = getc (adrfic);

    misajour = 1;

    return (fincharge ());
#else
    chargemem ();
#endif
}

int fincharge ()
{
    lignecurseur = 1;
    numlig = 0;
    sens   = 0;
    posdebuf ();
    sauveposbuf ();

#ifndef mxvi
    coldeblig = 1 + (6 * optnuml);
    majtmp = 0;
#else
    coldeblig = 1 + (8 * optnuml);
    optsave = 0;
#endif

    maxinsert = insertmax ();

    if (adrfic == 0)
        carfic = EOF;

    while (carfic != EOF)
    {
        if (carfic == CR && typefichier == MSDOS && optrecup == 0)
            carfic = getc (adrfic);

        if (maxinsert)
        {
            ajoutbuf (carfic);
            maxinsert --;
        }
        else
        {
#ifdef vi
            fprintf (stderr, "\rFichier %s trop grand, utiliser gvi\n",
                                                                nomfich);
#else ifdef gvi
            fprintf (stderr, "\rFichier %s trop grand, utiliser mxvi\n",
                                                                nomfich);
#endif
            fclose (adrfic);

            return (0);
        }

        if (carfic == EOL && lignecurseur <= lignecran)
        {
            if (lignecurseur < lignecran)
            {
                restorposbuf ();
                affligsuiv ();
                sauveposbuf ();
            }
            else
            {
                printf ("Chargement du fichier en cours ");
                lignecurseur ++;
            }
        }

        carfic = getc (adrfic);
    }

    fclose (adrfic);

#ifdef mxvi
    finchargemem ();
#endif

    while (lignecurseur < lignecran)
        affligsuiv ();

    lignecurseur = 1;

    colcurseur = coldeblig;

    return (1);
}

sauvbak ()
{
    struct ftime datmaj;
    char  chemin [szchemin], chemin2 [szchemin];
    char  *valenv, *carchn, *carchn2;
    int   nbbak;
    int   descfic;
    octet sauvcour;


    valenv = getenv ("NBBAK");

    nbbak = 0;

    while (chiffre (*valenv))
    {
        nbbak = (nbbak * 10) + *valenv - '0';
        valenv ++;
    }

    if (genchemin (chemin, "BAKDIR") || (nbbak > 0))
    {
        sauvcour = 1;
        printf ("et sauvegarde\r");

        if (nbbak < 1)
            nbbak = 1;

        else if (nbbak > 35)
            nbbak = 35;

        carchn = chemin + strlen (chemin);

        switch (strlen (suffixe))
        {
            case 0 : if (*(carchn - 1) != '.')
                     {
                         *carchn = '.';
                         carchn ++;
                     }
            case 1 :
            case 2 : carchn [1] = 0;
                     break;

            case 3 : carchn --;
        }

        *carchn = '1';
        *(carchn + 1) = 0;

        strcpy (chemin2, chemin);
        carchn2 = chemin2 + strlen (chemin2) - 1;

        if (nbbak < 10)
            *carchn = '0' + nbbak;
        else
            *carchn = '@' + nbbak - 9;

        *carchn2 = '0';
        unlink (chemin2);

        if (rename (chemin, chemin2) >= 0)
        {
            do
            {
                if (*carchn == '9')
                    *carchn = 'A';
                else
                    *carchn = *carchn + 1;
            }
            while (unlink (chemin) >= 0);
        }

        sauver (chemin2, 0L);

        if (carfic != EOF)
        {
            while (access (chemin2, 0) >= 0)
            {
                if (*carchn2 == '9')
                    *carchn2 = 'A';
                else
                    *carchn2 = *carchn2 + 1;
            }

            while (*carchn2 > '0')
            {
                *carchn = *carchn2;

                if (*carchn2 == 'A')
                    *carchn2 = '9';
                else
                    *carchn2 = *carchn2 - 1;

                rename (chemin2, chemin);
            }
        }
        else
            unlink (chemin2);
    }
    else
    {
        sauvcour = 0;
        putchar (CR);
    }

    if (genchemin (chemin, "HIERDIR") && carfic != EOF)
    {
        if (access (chemin, 0) == -1)
        {
            if (sauvcour == 0)
                printf ("\rSauvegarde de la version courante\r");

            sauver (chemin, 0L);

            if (carfic != EOF)
            {
                descfic = open (chemfich, 0x8001);

                if (descfic > 0)
                {
                    getftime (descfic, &datmaj);
                    close (descfic);
                }

                descfic = open (chemin, 0x8001);

                if (descfic > 0)
                {
                    setftime (descfic, &datmaj);
                    close (descfic);
                }
            }
            else
                unlink (chemin);
        }
    }

    if (carfic == EOF)
        message ("Manque d'espace disque pour sauvegarder la version courante");
}




int genchemin (chemin, varenv)
char *chemin, *varenv;
{
    char *valenv, *carchn;


    valenv = getenv (varenv);

    if (valenv)
    {
        strcpy (chemin, valenv);

        if (*chemin)
        {
            carchn = chemin + strlen (chemin) - 1;

            if (*carchn != '/' && *carchn != '\\')
            {
                mkdir (chemin);
                strcat (chemin, "/");
            }

            strcat (chemin, nomfich);
            return (1);
        }
    }

    strcpy (chemin, nomfich);
    return (0);
}

sauver (fichier, nomsauve)
char *fichier, *nomsauve;
{
    adrfic = fopen (fichier, "wb");

    if (adrfic != 0)
    {
        sauveposbuf ();

        posdebuf ();

        while (! finfichier ())
        {
            carfic = carcourant ();

            if ((carfic == EOL || carfic == CR) && typefichier == MSDOS)
                putc (CR, adrfic);

            putc (carfic, adrfic);

            avancebuf ();
        }

        carfic = fclose (adrfic);

        if (carfic != EOF)
        {
            affmode ();

            if (nomsauve)
            {
                putchar (CR);
                printf ("Fichier sauv dans %s", nomsauve);
            }

            misajour = 0;

#ifndef mxvi
            majtmp   = 0;
#endif
        }

        restorposbuf ();

#ifndef mxvi
        if (carfic == EOF)
        {
            if (access (ficsave, 0) >= 0)
            {
                unlink (ficsave);
                sauver (fichier, nomsauve);
            }
        }
        else
            unlink (ficsave);

        unlink (fictmp);
#endif
    }
    else
    {
        affmode ();
        putchar (CR);
        printf ("Fichier %s protg ou inaccessible", fichier);
    }
}

#ifndef mxvi

sauvtmp ()
{
    octet i;


    adrfic = fopen (fictmp, "wb");

    if (adrfic != 0)
    {
        for (i = 0; i < szsuffixe; i++)
            putc (suffixe [i], adrfic);

        putc (typefichier, adrfic);
        putw (numlig, adrfic);

        sauveposbuf ();

        posdebuf ();

        while (! finfichier () && (i++ != 0 || bioskey (1) == 0))
        {
            carfic = carcourant ();

            putc (carfic, adrfic);

            avancebuf ();
        }

        carfic = fclose (adrfic);

        if (carfic == EOF)
        {
            if (access (ficsave, 0) >= 0)
                unlink (ficsave);
            else
            {
                majtmp = 0;
                unlink (fictmp);
            }
        }
        else if (finfichier ())
        {
            unlink (ficsave);
            rename (fictmp, ficsave);
            majtmp = 0;
        }
        else
            unlink (fictmp);

        restorposbuf ();
    }
}

#endif

/*
     Interface oprateur des programmes vi, gvi et mxvi
*/



/* Procdures de saisie et de traitement des commandes oprateur */

edition ()
{
    octet errutil, nberr;  /* comptage des erreurs conscutives utilisateur */

    posdebuf ();
    numlig = 1;
    duplibuf ();

    if (savenuml)
        descend (savenuml - 1);

    affmode ();

    termine = 0;
    nberr = 0;

    do
    {
        leccar ();

        nbfois = 0;

        while ('0' <= car && car <= '9')
        {
            nbfois = (nbfois * 10) + (car - '0');

            leccar ();

            while (car == TBKSP)
            {
                nbfois = nbfois / 10;
                leccar ();
            }
        }

        errutil = 0;

        switch (car)
        {
            case 'l'     :
            case AVANCE  : if (nbfois == 0)
                               avance (1);
                           else
                               avance (nbfois);

                           break;

            case 'h'     :
            case RECULE  :
            case TBKSP   : if (nbfois == 0)
                               recule (1);
                           else
                               recule (nbfois);

                           break;

            case 'k'     :
            case MONTE   : if (nbfois == 0)
                               monte (1);
                           else
                               monte (nbfois);

                           break;

            case 'j'     :
            case DESCEND :
            case ENTER   : if (nbfois == 0)
                               descend (1);
                           else
                               descend (nbfois);

                           break;

            case '^'     : premiercar ();
                           break;

            case HOME    : debligne ();
                           break;

            case '$'     :
            case END     : finligne ();
                           recule (1);
                           break;

            case PAGEDOWN: if (nbfois == 0)
                               nbfois = 1;

                           descend ((lignecran - 1) * (nbfois + 1)
                                                    - lignecurseur);

                           break;

            case PAGEUP  : if (nbfois == 0)
                               nbfois = 1;

                           monte ((lignecran - 1) * nbfois + lignecurseur - 1);

                           break;

            case '%'     : rechlimite ();
                           break;

            case 'a'     : avance (1);

            case 'i'     : synchrocol ();
                           insertion ();
                           break;

            case 'I'     : premiercar ();
                           insertion ();
                           break;

            case 'A'     : finligne ();
                           insertion ();
                           break;

            case 'r'     : if (nbfois == 0)
                               nbfois = 1;

                           synchrocol ();
                           rempl_ncar ();
                           break;

            case 'R'     : synchrocol ();
                           remplace ();
                           break;

            case 'c'     : if (nbfois == 0)
                               nbfois = 1;

                           if (resyncbuf == 1)
                               synchrocol ();

                           leccar ();

                           if (car == 'w')
                               substitue (nbcarmot (nbfois, 0));

                           else if (car == 'W')
                               substitue (nbcarbloc (nbfois, 0));
                           else
                               bip ();

                           break;

            case 's'     : if (nbfois == 0)
                               nbfois = 1;

                           substitue (nbfois);
                           break;

            case '~'     : tilde ();
                           break;

            case 'J'     : if (nbfois == 0)
                               nbfois = 1;

                           joint ();
                           break;

            case SUPPRIME:
            case 'x'     : detruit_avant (nbfois);
                           break;

            case 'X'     : detruit_arriere (nbfois);
                           break;

            case 'd'     : if (nbfois == 0)
                               nbfois = 1;

                           if (resyncbuf == 1)
                               synchrocol ();

                           leccar ();

                           if (car == 'd')
                           {
                               debligne ();
                               detruit_avant (nbcarlig (nbfois));
                           }
                           else if (car == 'w')
                               detruit_avant (nbcarmot (nbfois, 1));

                           else if (car == 'W')
                               detruit_avant (nbcarbloc (nbfois, 1));
                           else
                               bip ();

                           break;

            case 'D'     : if (nbfois == 0)
                               nbfois = 1;

                           if (resyncbuf == 1)
                               synchrocol ();

                           detruit_avant (nbcarlig (nbfois) - 1);
                           break;

            case 'S'     : Scom ();
                           break;

            case 'C'     : if (nbfois == 0)
                               nbfois = 1;

                           if (resyncbuf == 1)
                               synchrocol ();

                           substitue (nbcarlig (nbfois) - 1);
                           break;

            case 'n'     : if (sens != 0)
                           {
                               *commande = 0;
                               recherche ();
                           }
                           else
                               message ("Aucune chaine  rechercher n'a t prcise");

                           break;

            case 'u'     :
            case 'U'     :
#ifndef gvi
                           undo ();
                           poscurseur (lignecurseur, colcurseur);
                           reaffiche ();
#else
                           if (undo_ok > 0)
                           {
                               undo ();
                               poscurseur (lignecurseur, colcurseur);
                               reaffiche ();
                           }
                           else if (undo_ok == 0)
                               message ("Fichier trop gros pour la commande undo");
                           else
                               message ("Commande undo interdite aprs :!<commande>");
#endif
                           break;

            case CTRL    : reaffiche ();
                           break;

            case CTRG    : sauveposit ();
                           baspage ();
                           printf ("Ligne ");
                           affnumlig (' ');
                           printf ("                      ");
                           restorposit ();
                           break;

            case '/'     :
            case '?'     :
            case ':'     :
            case '!'     : if (lignecurseur < lignecran)
                               sauveposit ();

                           saisie ();

                           if (car == ENTER && szcom > 0)
                               trtsaisie ();
                           else
                           {
                               affmode ();
                               restorposit ();
                           }

                           break;

            case HELP    : if (ficaide > 0)
                           {
                               sauveposit ();
                               putseq ("24B");
                               aide ();
                               restorposit ();
                               affmode ();
                           }
                           else
                               message ("Fichier d'aide en ligne manquant");

                           break;

            default      : bip ();
                           errutil = 1;
        }

        if (errutil)
        {
            nberr ++;

            if (nberr == err_av_help && ficaide > 0)
            {
                sauveposit ();
                baspage ();
                printf ("Appuyer sur la touche F1 pour avoir l'aide en ligne");
                restorposit ();
                nberr = 0;
            }
        }
        else
            nberr = 0;
    }
    while (termine == 0);

#ifndef mxvi
    unlink (ficsave);
    unlink (fictmp);
#else
    libmem ();
    unlink (fictrav);
#endif
}

saisie ()
{
    char i;


    baspage ();
    effligne ();

    affcar (car);

    poscom = 0;

    if (car != ':')
        commande [poscom++] = car;

    szcom = poscom;

    leccar ();

    while (car != ENTER && car != ESCAPE)
    {
        if (car < CARSPE)
        {
            if (szcom == poscom)
            {
                if (colcurseur < colonecran)
                {
                    caracc = testaccent ();

                    if (caracc == 0)
                    {
                        commande [poscom++] = car;
                        szcom = poscom;
                        affcar (car);
                    }
                    else
                    {
                        putchar (BKSP);
                        putchar (caracc);
                        commande [poscom - 1] = caracc;
                    }
                }
                else
                    bip ();
            }
            else
            {
                if (car >= ' ')
                {
                    if (commande [poscom] < ' ')
                        delcar (1);
                }
                else
                {
                    if (commande [poscom] >= ' ')
                        inscar (1);
                }

                commande [poscom++] = car;
                affcar (car);
            }
        }
        else
        {
            switch (car)
            {
                case AVANCE   : if (poscom == szcom)
                                {
                                    if (colcurseur < colonecran)
                                    {
                                        commande [poscom++] = ' ';
                                        szcom = poscom;
                                        affcar (' ');
                                    }
                                    else
                                        bip ();
                                }
                                else
                                {
                                    if (commande [poscom++] < ' ')
                                        putseq ("2C");
                                    else
                                        putseq ("C");
                                }
                                break;

                case RECULE   : if (colcurseur > 2)
                                {
                                    if (commande [--poscom] < ' ')
                                        putseq ("2D");
                                    else
                                        putseq ("D");
                                }
                                else
                                    bip ();

                                break;

                case TBKSP    : if (colcurseur > 2)
                                {
                                    if (commande [--poscom] < ' ')
                                        printf (" ");

                                    printf (" ");

                                    commande [poscom] = ' ';
                                }
                                else
                                    bip ();

                                break;

                case INSERE   : if (poscom < szcom)
                                {
                                    inscar (1);

                                    for (i = szcom; i >= poscom; i--)
                                        commande [i + 1] = commande [i];

                                    commande [poscom] = ' ';
                                    szcom++;
                                }

                                break;

                case SUPPRIME : if (poscom < szcom)
                                {
                                    if (commande [poscom] < ' ')
                                        delcar (2);
                                    else
                                        delcar (1);

                                    for (i = poscom; i < szcom; i++)
                                        commande [i] = commande [i + 1];

                                    szcom--;
                                }

                                break;

                default       : bip ();
            }
        }

        leccar ();
    }

    if (*commande != '/' && *commande != '?')
    {
        while (szcom > 1 && commande [szcom - 1] == ' ')
            szcom --;
    }
    else
    {
        if (szcom > 1 && commande [szcom - 1] == *commande)
            szcom --;
    }

    commande [szcom] = 0;
}

trtsaisie ()
{
    intxx posdeb, posfin;


    poscom = 0;


    if (chiffre (*commande) || *commande == '+' || *commande == '-'
                                                || *commande == '$')
        posdeb = valeur ();
    else
        posdeb = numlig;

    if (commande [poscom] == ',')
    {
        poscom ++;

        if (chiffre (commande [poscom]) || commande [poscom] == '+'
            || commande [poscom] == '-' || commande [poscom] == '$')
            posfin = valeur ();
        else
            poscom = 0;  /* pour dtection erreur de syntaxe */
    }
    else
        posfin = posdeb;

    if (poscom == 0)
    {
        switch (*commande)
        {
            case '/' :
            case '?' : recherche ();
                       break;

            case '!' : if (szcom > 1)
                           shell ();
                       else
                       {
                           restorposit ();
                           affmode ();
                       }
                       break;

            case 'c' : if (mot ("copy"))
                           copy (numlig, numlig);
                       else
                           errsynt ();
                       break;

            case 'm' : if (mot ("move"))
                           move (numlig, numlig);
                       else
                           errsynt ();
                       break;

            case 'r' : rcom (numlig);
                       break;

            case 's' : if (commande [poscom + 1] == '/')
                           majauto (numlig, numlig);
                       else
                       {
                           if (commande [++poscom] == 'e')
                               if (commande [++poscom] == 't')
                                   poscom ++;

                           if (commande [poscom] == ' ')
                               setopt ();
                           else
                               errsynt ();
                       }
                       break;

            case 'w' : writefic ();
                       break;

            case 'q' : if (misajour == 0 || commande [1] == '!')
                           termine = 1;
                       else
                           errcom ("\rLe fichier a t modifi. Taper :q! ou :wq");

                       break;

            default  : errsynt ();
        }
    }
    else if (posdeb > posfin)
        errcom ("Ligne de dbut suprieure  la ligne de fin");
    else
    {
        if (commande [poscom] == 0)
        {
            restorposit ();
            positionner (posdeb);
        }
        else if (commande [poscom] == 'r')
            rcom (posdeb);

        else if (commande [poscom] == 's' && commande [poscom + 1] == '/')
            majauto (posdeb, posfin);

        else if (mot ("move"))
            move (posdeb, posfin);

        else if (mot ("copy"))
            copy (posdeb, posfin);

        else
        {
            errsynt ();
            puts (&commande [poscom]);
        }
    }
}

setopt ()
{
    octet valsuiv;


    putchar (CR);
    effligne ();
    affmode ();

    while (commande [++poscom] == ' ');

    if (memcmp (commande + poscom, "no", 2) == 0)
    {
        poscom = poscom + 2;
        valsuiv = 0;
    }
    else
        valsuiv = 1;

    switch (commande [poscom])
    {
        case 'n' : optnuml = valsuiv;
                   restorposit ();
#ifndef mxvi
                   coldeblig = 1 + (6 * optnuml);
#else
                   coldeblig = 1 + (8 * optnuml);
#endif
                   colonref = coldeblig;
                   colcurseur = coldeblig;
                   reaffiche ();
                   break;

        case 'r' : optregul = valsuiv;

                   if (optregul)
                       printf ("\rTraitement des expressions rgulires");
                   else
                       printf ("\rPas de traitement des expressions rgulires");

                   restorposit ();
                   break;

        case 'c' :
        case 'p' : if (valsuiv == 1)
                       optescape = commande [poscom];
                   else
                       optescape = 0;

                   restorposit ();
                   break;

        case 'a' : if (commande [poscom + 1] == 'i')
                   {
                       optindente = valsuiv;

                       if (optindente)
                           printf ("\rAutoindentation");
                       else
                           printf ("\rPas d'autoindentation");

                       restorposit ();
                   }
                   else if (commande [poscom + 1] == 'c')
                   {
                       optaccent = valsuiv;

                       if (optaccent)
                           printf ("\rTraitement des accents");
                       else
                           printf ("\rPas de traitement des accents");

                       restorposit ();
                   }
                   else
                       errcom ("Option saisie inconnue");

                   break;

        default  : errcom ("Option saisie inconnue");
    }
}

shell ()
{
#ifdef gvi
    packmem ();
#endif

    if (farcoreleft () < minmemocom)
        errcom ("Mmoire insuffisante pour lancer une commande");
    else
    {
        putchar (EOL);
        system (&commande [1]);
        printf ("Appuyer sur une touche pour continuer ");

        if (nextcar () != '!')
        {
            restorposit ();
            reaffiche ();
            affmode ();
        }
    }

#ifdef gvi
    unpackmem ();
#endif
}

rcom (position)
intxx position;
{
    octet portee;
    intxx lignedeb, lignefin;
    char  nouvcom [colonecran + 20];
    char  *fichier;
    static char ficshell [] = "!@#$%^&.(-)";  /* peu de risque d'avoir dj
                                                 un fichier de ce nom */

    poscom ++;

    if (commande [poscom] == '!')
    {
        poscom ++;

        while (commande [poscom] == ' ')
            poscom ++;

        if (commande [poscom] == 0)
        {
            affmode ();
            restorposit ();
        }

        else
        {
#ifdef gvi
            packmem ();
#endif
            if (farcoreleft () < minmemocom)
            {
                errcom ("Mmoire insuffisante pour lancer une commande");
#ifdef gvi
                unpackmem ();
#endif
            }
            else
            {
                strcpy (nouvcom, "redirect \"> ");
                strcat (nouvcom, ficshell);
                strcat (nouvcom, "\" \"2>&1\" ");
                strcat (nouvcom, &commande [poscom]);

                system (nouvcom);
#ifdef gvi
                unpackmem ();
#endif
                ajoutfic (position, ficshell, 1, nbmaxlig);
                unlink (ficshell);
            }
        }
    }
    else
    {
        portee = commande [poscom];

        if (portee == 'l' || portee == 'p')
            poscom++;

        if (commande [poscom] == ' ')
        {
            sautblancs ();

            fichier = &commande [poscom];

            lignedeb = 1;
            lignefin = nbmaxlig;

            if (portee != ' ')
            {
                do
                    poscom ++;
                while ((commande [poscom] | ' ') != ' ');

                commande [poscom] = 0;   /* fin du nom du fichier */

                sautblancs ();

                if (chiffre (commande [poscom]))
                {
                    lignedeb = valeur ();
                    sautblancs ();

                    if (portee == 'p')
                    {
                        if (chiffre (commande [poscom]))
                            lignefin = valeur ();
                    }
                    else
                        lignefin = lignedeb;
                }
            }

            if (portee == 'l' && lignedeb != lignefin)
                errcom ("Il faut prciser un numro de ligne");
            else
                ajoutfic (position, fichier, lignedeb, lignefin);
        }
        else
            errsynt ();
    }
}

writefic ()
{
    if (commande [1] == ' ')
    {
        sautblancs ();
        sauver (&commande [poscom], &commande [poscom]);
        restorposit ();

        if (carfic == EOF)
            unlink (&commande [poscom]);
    }
    else
    {
        if (commande [1] == 'q')
        {
            sauver (chemfich, nomfich);

            if (misajour)
                restorposit ();
            else
                termine = 1;
        }
        else
        {
            sauver (chemfich, 0L);
            affmode ();
            restorposit ();
        }
    }

    if (carfic == EOF)
        message ("Manque d'espace disque !");
}




errsynt ()
{
    errcom ("Syntaxe de la commande incorrecte");
}




errcom (chaine)
char *chaine;
{
    affmode ();
    putchar (CR);
    printf (chaine);
    restorposit ();
    bip ();
}

intxx valeur ()
{
    long val;
    char signe;


    if (commande [poscom] == '$')
    {
        poscom ++;
        return (nbmaxlig);
    }

    if (commande [poscom] == '+' || commande [poscom] == '-')
    {
        signe = commande [poscom ++];
        val = 0;
    }
    else
    {
        val = commande [poscom++] - '0';
        signe = 0;
    }

    while (poscom < szcom && chiffre (commande [poscom]))
        val = (val * 10) + commande [poscom++] - '0';

    if (signe == '+')
    {
        if (val == 0)
            val = numlig + 1;
        else
            val = val + numlig;

        if (val > nbmaxlig)
            return (nbmaxlig);
        else
            return (val);
    }
    else if (signe == '-')
    {
        if (val == 0)
            val = numlig - 1;
        else
            val = numlig - val;

        if (val > 0)
            return (val);
        else
            return (0);
    }
    else
        return (val);
}

int mot (chaine)
char *chaine;
{
    octet savpos;


    savpos = poscom;

    while (*chaine && commande [poscom] == *chaine)
    {
        chaine ++;
        poscom ++;
    }

    if (*chaine || lettre (commande [poscom]))
    {
        poscom = savpos;
        return 0;
    }
    else
    {
        while (commande [poscom] == ' ')
            poscom ++;

        return (1);
    }
}




sautblancs ()
{
    do
        poscom ++;
    while (commande [poscom] == ' ');
}

intxx nbcarlig (lignes)
intxx lignes;
{
    intxx nbcar;


    sauveposbuf ();

    nbcar = 0;

    fflush (stdout);     /* supprime dfaut pour raison inconnue !!!! */

    do
    {
        nbcar++;

        if (carcourant () == EOL)
            lignes --;

        avancebuf ();
    }
    while (lignes > 0 && ! finfichier ());

    restorposbuf ();

    return (nbcar);
}

intxx nbcarmot (mots, blancsfin)
intxx mots;
octet blancsfin;
{
    intxx nbcar;


    sauveposbuf ();

    nbcar = 0;

    if (separateur (carcourant ()))
    {
        mots --;

        do
        {
            avancebuf ();
            nbcar ++;
        }
        while (separateur (carcourant ()));
    }

    while (mots > 0 && ! finfichier ())
    {
        if (lettre (carcourant ()))
        {
            mots --;

            do
            {
                avancebuf ();
                nbcar ++;
            }
            while (lettre (carcourant ()));
        }
        else if (chiffre (carcourant ()))
        {
            mots --;

            do
            {
                avancebuf ();
                nbcar ++;
            }
            while (chiffre (carcourant ()));
        }
        else if (separateur (carcourant ()))
        {
            do
            {
                avancebuf ();
                nbcar ++;
            }
            while (separateur (carcourant ()));
        }
        else
        {
            mots --;

            avancebuf ();
            nbcar ++;
        }
    }

    if (blancsfin && carcourant () == ' ')
    {
        do
        {
            avancebuf ();
            nbcar ++;
        }
        while (carcourant () == ' ');
    }

    restorposbuf ();

    return (nbcar);
}

intxx nbcarbloc (blocs, blancsfin)
intxx blocs;
octet blancsfin;
{
    intxx nbcar;


    sauveposbuf ();

    nbcar = 0;

    if (separateur (carcourant ()))
    {
        blocs --;

        do
        {
            avancebuf ();
            nbcar ++;
        }
        while (separateur (carcourant ()));
    }

    while (blocs > 0 && ! finfichier ())
    {
        if (separateur (carcourant ()))
        {
            blocs --;

            if (blocs > 0)
            {
                do
                {
                    avancebuf ();
                    nbcar ++;
                }
                while (separateur (carcourant ()));
            }
        }
        else
        {
            avancebuf ();
            nbcar ++;
        }
    }

    if (blancsfin && carcourant () == ' ')
    {
        do
        {
            avancebuf ();
            nbcar ++;
        }
        while (carcourant () == ' ');
    }

    restorposbuf ();

    return (nbcar);
}

int testaccent ()
{
    if (optaccent == 1)
    {
        switch (car)
        {
            case '\'': if (carpred == 'e')
                           return (eaigu);
                       break;

            case '`' : if (carpred == 'a')
                           return (agrave);

                       else if (carpred == 'e')
                           return (egrave);

                       else if (carpred == 'u')
                           return (ugrave);

                       break;

            case '^' : if (carpred == 'a')
                           return (acirc);

                       else if (carpred == 'e')
                           return (ecirc);

                       else if (carpred == 'i')
                           return (icirc);

                       else if (carpred == 'o')
                           return (ocirc);

                       else if (carpred == 'u')
                           return (ucirc);

                       break;

            case '"' : if (carpred == 'e' || carpred == 'i')
                       {
                           inscar (1);
                           putchar (car);
                           nextcar ();
                           putchar (BKSP);
                           delcar (1);

                           if (carsuiv == '"')
                           {
                               suivantlu = 0;

                               if (carpred == 'e')
                                   return (etrema);
                               else
                                   return (itrema);
                           }
                       }
                       break;

            case ',' : if (carpred == 'c' || carpred == 'C')
                       {
                           inscar (1);
                           putchar (car);
                           nextcar ();
                           putchar (BKSP);
                           delcar (1);

                           if (carsuiv == 'a' || carsuiv == 'o' || carsuiv == 'u')
                           {
                               if (carpred == 'c')
                                   return (ccedille);
                               else
                                   return (Ccedille);
                           }
                       }
                       break;

            case '=' : if (carpred == 'C')
                           return (EURO);

                       break;
        }
    }

    return 0;
}

int testacc2 ()
{
    if (optaccent == 1)
    {
        switch (car)
        {
            case 'a' : nextcar ();

                       if (carsuiv == '`')
                           return (agrave);

                       else if (carsuiv == '^')
                           return (acirc);

                       break;

            case 'e' : nextcar ();

                       if (carsuiv == '`')
                           return (egrave);

                       else if (carsuiv == '\'')
                           return (eaigu);

                       else if (carsuiv == '^')
                           return (ecirc);

                       else if (carsuiv == '"')
                           return (etrema);

                       break;

            case 'i' : nextcar ();

                       if (carsuiv == '^')
                           return (icirc);

                       else if (carsuiv == '"')
                           return (itrema);

                       break;

            case 'o' : if (nextcar () == '^')
                           return (ocirc);

                       break;

            case 'u' : nextcar ();

                       if (carsuiv == '`')
                           return (ugrave);

                       else if (carsuiv == '^')
                           return (ucirc);

                       break;

            case 'c' :
            case 'C' : nextcar ();

                       if (carsuiv == ',')
                       {
                           carsuiv = carcourant ();

                           if (carsuiv == 'a' || carsuiv == 'o' || carsuiv == 'u')
                           {
                               if (car == 'c')
                                   return (ccedille);
                               else
                                   return (Ccedille);
                           }
                       }

                       else if (carsuiv == '=')
                           return (EURO);

                       break;
        }
    }

    return 0;
}

int testx ()
{
    if (car == 'x' && carpred == '\\')
        return (codehexa ());
    else
        return 0;
}



int testx2 ()
{
    if (car == '\\')
    {
        nextcar ();

        if (carsuiv == 'x')
        {
            suivantlu = 0;

            return (1);
        }
    }

    return 0;
}



int codehexa ()
{
    octet valhexa;


    putchar (BKSP);
    putchar ('x');

    leccar ();

    if (chiffre (car))
        valhexa = car & 0x0F;
    else
        valhexa = (car & 7) + 9;

    leccar ();

    if (chiffre (car))
        return (valhexa << 4) | (car & 0x0F);
    else
        return (valhexa << 4) | ((car & 7) + 9);
}

int chiffre (caract)
char caract;
{
    return ('0' <= caract && caract <= '9');
}




int lettre (caract)
octet caract;
{
    return (('a' <= (caract | 0x20) && (caract | 0x20) <= 'z') ||
                          (Ccedille <= caract && caract <= 0xA5));
}




int separateur (caract)
char caract;
{
    return (caract == ' ' || caract == EOL || caract == CTRL
                          || caract == TAB || caract == CR);
}




bip ()
{
    putchar (BIP);
}

/* aide sur l'utilisation de l'outil */
aide ()
{
    int n;   /* slection de l'oprateur */


    mes_aide (0);

    n = 0;
    leccar ();

    while ('0' <= car && car <= '9')
    {
        putchar (car);

        n = (n * 10) + car - '0';

        leccar ();
    }

    /* afficher la page de documentation slectionne */
    if (n > 0 && n <= 18)
        mes_aide (n);
    else
    {
        puts ("  Erreur !\r");
        bip ();
    }

    printf ("\n     Appuyer sur une touche revenir au fichier");
    leccar ();

    if (car == HELP)
        aide ();
    else
        reaffiche ();
}

/* affichage d'une page de la documentation en ligne */
int mes_aide (n)
int n;
{
    int car;     /* caractre du fichier d'aide en ligne */


    /* se positionner sur la page  afficher */
    rewind (ficaide);

    while (n > 0)
    {
        car = getc (ficaide);

        if (car == CTRL)
            n--;
    }

    puts ("\n");

    car = getc (ficaide);

    /* afficher la page */
    while ((car != CTRL) && (car != EOF))
    {
        /* traitement du dlimiteur de page d'cran */
        if (car == 0)
        {
            printf ("     Appuyer sur une touche pour continuer");
            leccar ();
            putchar (CR);
            effligne ();
        }
        else if (car == '~')
        {
#ifdef gvi
            putchar ('g');
#else
            ;  /* on saute le caractre */
#endif
        }
        else
            putchar (car);

        car = getc (ficaide);
    }
}

/* Sous programmes spcifiques  MS-DOS */

leccar ()
{
    carpred = car;

    if (suivantlu == 0)
    {
        if (bioskey (1) == 0 && reaffmode == 1)
            affmode ();

        attente_car ();

        car = codecar ();
    }
    else
    {
        car = carsuiv;
        suivantlu = 0;
    }
}




int nextcar ()
{
    attente_car ();

    carsuiv = codecar ();

    suivantlu = 1;

    return (carsuiv);
}




supcarid ()
{
    while (bioskey (1) && nextcar () == car)
        suivantlu = 0;
}

attente_car ()
{
#ifndef mxvi
    long heuresauv;
#endif
    long heuralarme;


    heuralarme = clock () + att_alarme;

#ifndef mxvi
    heuresauv = clock () + (att_clavier * TIC_SEC);

    if (heuresauv < heuremajsuiv)
        heuresauv = heuremajsuiv;

    while (bioskey (1) == 0 && majtmp)
    {
        if (heuresauv <= clock ())
            sauvtmp ();
    }
#endif

    while (bioskey (1) == 0 && att_alarme)
    {
        if (heuralarme <= clock ())
        {
            alarme ();
            heuralarme = heuralarme + att_alarme;
        }
    }
}



alarme ()
{
    long freq;
    int  i;


    delai (0);

    for (i = 0; i < 4; i++)
    {
        freq = freq_deb;

        while (freq < freq_max && bioskey (1) == 0)
        {
            sound (freq);
            delai (3);
            freq = (freq << 7) / 127;
        }
        nosound ();

        delai (100);
    }

    nosound ();
}

/* temporisation en millisecondes */
delai (duree)
unsigned duree;
{
    static long pas_etalon = 0;
    long pas_avant_tic;
    long pas_restants;
    long der_heure;
    unsigned ecoule;


    if (duree == 0 || pas_etalon == 0)
    {
        pas_avant_tic = 0;

        der_heure = clock ();

        do
            pas_avant_tic ++;
        while (der_heure == clock ());

        der_heure ++;
        pas_etalon = 0;

        do
            pas_etalon ++;
        while (der_heure == clock ());

        ecoule = 55 + (55 * pas_avant_tic / pas_etalon);

        if (duree > ecoule)
            duree = duree - ecoule;
        else
            duree = 0;
    }

    pas_restants = duree * pas_etalon / 55;

    while (pas_restants-- > 0)
        der_heure = clock ();
}




int codecar ()
{
    int carlu;


    carlu = bioskey (0);

    if ((carlu & 0xFF) == 0)
    {
        if (carlu != CTRL0)
            return (CARSPE | (carlu >> 8));
        else
            return (0);
    }
    else
    {
        if (carlu != TBKSP && carlu != ESCAPE && carlu != ENTER)
            return (carlu & 0xFF);
        else
            return (carlu);
    }
}
